/**
* Efetua o Calculo do CD do MSISDN
* @author Ivan Nagy
* @since 2002-11-01
**/
public final class CalculaCDCelular
{

	public CalculaCDCelular(){}

	/**
	* Devera receber o numero do Celular sem formatacao
	* @param Celular
	* @return CD
	**/
	public static String getCD( String pCelular ) throws Exception
	{
		int CD=0;
		int soma=0;
		int coef[] = { 38,62,45,53,15,50,5,49,34,81 };

		try
		{
			for( int widx = 0; widx < 10; widx++ )
			{
				soma += ( Integer.parseInt( pCelular.substring( widx,widx+1 ) ) * coef[ widx ] );
			}

			CD = 98 - ( soma % 97 );
		}
		catch( Exception exp )
		{
			throw new Exception( "Celular invalido" );
		}

		//Nao sei utilizar mascara por isso efetuei uma gambi tecnica
		String wcd_str = Integer.toString( CD );
		if( wcd_str.length() == 1 )
			wcd_str = "0" + wcd_str.trim();

		return wcd_str;
	}

	/**
	* Devera receber o numero do Celular e o CD para efetuar a comparacao
	* @param Celular,CD
	* @return true se o CD for Ok e false se CD estivar errado
	**/
	public static boolean isCD( String pCelular,String pCD ) throws Exception
	{
		try
		{
			if( getCD( pCelular ).equals( pCD.trim() ) )
				return true;
		}
		catch( Exception exp )
		{
			throw new Exception( "Celular invalido" );
		}

		return false;
	}
}

