import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import java.text.*;

/**
* Diversas verificacoes de String
* @author Ivan Nagy
* @since 2002-10-03
**/
public final class CheckString
{
	public CheckString(){}

	/**
	* Valida se String esta nula
	* @param pStr String
	* @return true para NAO NULA e false para NULA
	**/
	public static boolean isNull( String pStr )
	{
		if( pStr.trim().length() == 0 )
			return false;

		return true;
	}


	/**
	* Valida se a string contem caracter alfabetico
	* @param pStr String
	* @return true para toda numerica -- false se possuir caracter alfabetico
	**/
	public static boolean isNumeric( String pStr )
	{
		String wStr,wStr1;
		char wChr;

		for (int i = 0; i < pStr.length(); i++)
		{
			wStr1 = pStr.substring( i,i + 1 );
			wChr = wStr1.charAt( 0 );

			if( Character.isDigit( wChr ) == false )
				return false;
		}

		return true;
	}

	/**
	* <B>Em definicao</B>
	* @param pStr String
	* @return true para NAO NULA e false para NULA
	**/
	public static boolean isNegativ( int pInt )
	{
		if( pInt < 0 )
		{
			return false;
		}
		return true;
	}


	/**
	* Valida se String e apenas numeros e letras
	* @param pStr String
	* @return true se NAO possuir caracteres estranhos e false se possur
	**/
	public static boolean isCharacEspec( String pStr )
	{
		String wStr,wStr1;
		char wChr;

		pStr = pStr.replace( ' ','X' );

		for (int i = 0; i < pStr.length(); i++)
		{
			wStr1 = pStr.substring( i,i + 1 );
			wChr = wStr1.charAt( 0 );

			if( Character.getNumericValue(wChr) < 0 )
				return false;
		}

		return true;
	}

	/**
	* Verifica se existe determinado caracter
	* @param pStr String
	* @return true se existir e false se nao existir
	**/
	public static boolean checkDigit( String pStr, String pEspec )
	{
		if( pStr.indexOf( pEspec ) < 0 )
			return false;

		return true;
	}
}