import java.awt.*;
import java.awt.event.*;

public class ClienteFiscal extends Panel implements KeyListener
{
	private TextField txtLocal;
	private TextField txtNotaFisc;
	private TextField txtCNPJ;
	private TextField txtInscEst;
	private String focus;
	private Parametro param = new Parametro();

	public ClienteFiscal()
	{
		focus=".";
		Label lblLocal = new Label("Local da compra:");
		Label lblNotaFisc = new Label("Nota Fiscal:");
		Label lblCNPJ = new Label("CNPJ:");
		Label lblInscEst = new Label("Inscrio Estadual:");

		//********************************
		txtLocal = new TextField();
		txtLocal.setName("txtLocal");
		txtLocal.addKeyListener(this);
		txtLocal.setBackground(Color.white);
		txtLocal.setForeground(Color.black);
		txtLocal.setFont(param.get_Fonte());
		//********************************
		txtNotaFisc = new TextField();
		txtNotaFisc.setName("txtNotaFisc");
		txtNotaFisc.addKeyListener(this);
		txtNotaFisc.setBackground(Color.white);
		txtNotaFisc.setForeground(Color.black);
		txtNotaFisc.setFont(param.get_Fonte());
		//********************************
		txtCNPJ = new TextField();
		txtCNPJ.setName("txtCNPJ");
		txtCNPJ.addKeyListener(this);
		txtCNPJ.setBackground(Color.white);
		txtCNPJ.setForeground(Color.black);
		txtCNPJ.setFont(param.get_Fonte());
		//********************************
		txtInscEst = new TextField();
		txtInscEst.setName("txtInscEst");
		txtInscEst.addKeyListener(this);
		txtInscEst.setBackground(Color.white);
		txtInscEst.setForeground(Color.black);
		txtInscEst.setFont(param.get_Fonte());
		//********************************

		GridBagConstraints gbcConstraints = new GridBagConstraints();
		GridBagLayout gblDados = new GridBagLayout();
		AddGridComponente grdAddDados = new AddGridComponente(gblDados,gbcConstraints,3,20);

		grdAddDados.addComponente(lblLocal,gblDados,gbcConstraints,1,1,1,1);
		grdAddDados.addComponente(lblCNPJ,gblDados,gbcConstraints,2,1,1,1);

		//************* Local e Nota ClienteFiscal **************
		grdAddDados.addComponente(txtLocal,gblDados,gbcConstraints,1,2,1,8);
		grdAddDados.addComponente(lblNotaFisc,gblDados,gbcConstraints,1,11,1,1);
		grdAddDados.addComponente(txtNotaFisc,gblDados,gbcConstraints,1,12,1,8);

		//************* CNPJ e Insc. Estadual **************
		grdAddDados.addComponente(txtCNPJ,gblDados,gbcConstraints,2,2,1,8);
		grdAddDados.addComponente(lblInscEst,gblDados,gbcConstraints,2,11,1,1);
		grdAddDados.addComponente(txtInscEst,gblDados,gbcConstraints,2,12,1,8);

		setLayout(new GridLayout(1,1));
		add(grdAddDados);
		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
	}

	/*
	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		Dimension d = getSize();

		g.setColor(param.get_BackColor());
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.yellow);
		g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);
	}

	public Insets getInsets()
	{
		return new Insets(10,10,10,10);
	}*/

	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e)	{}

	public void reset()
	{
		setLocal("");
		setNotaFisc("");
		setCNPJ("");
		setInscEst("");
	}

	public String getLocal()
	{
		return txtLocal.getText().toUpperCase();
	}

	public String getNotaFisc()
	{
		return txtNotaFisc.getText();
	}

	public String getCNPJ()
	{
		return txtCNPJ.getText();
	}

	public String getInscEst()
	{
		return txtInscEst.getText();
	}

	public void setLocal(String local)
	{
		txtLocal.setText(local.toUpperCase());
	}

	public void setNotaFisc(String nf)
	{
		txtNotaFisc.setText(nf);
	}

	public void setCNPJ(String cnpj)
	{
		txtCNPJ.setText(cnpj);
	}

	public void setInscEst(String ie)
	{
		txtInscEst.setText(ie);
	}
}
