import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.URL;
import java.util.StringTokenizer;

public class MenuButton extends Applet implements Runnable
{
	Thread thread;
	Image img, img1, vImg[];
	Graphics graph;
	int width, height, count, altura, posicao, offsetX, offsetY,
		posXA[], posYA[], posXB[], posYB[], backHColor, backHC, backHColorMask,
		indice, indice1, pressedItem, backColor, backHighColor, fontColor, fontHighColor,
		shadowColor, shadowHighColor, backColorResult, backHCResult, backHColorResult,
		backColorMaskResult, buttonType, tamFonte, modoFonte, largura;

	String 	parametro[], conteudo[], param, statusString, fonte, align, status, delimiter,
			msg[] = {"Pgina da Telesp Celular",
					 "",
					 "",
			         "",
			         "",
			         "",
			         "",
			         "",
			         "",
			         "",
			         "",
			         "",
			         "",
					 "",
					 "",
					 ""};
	URL page[];
	Frame frm;
	boolean isHorizontal, border, controle, controle1;

    public MenuButton()
    {
        indice = -1;
        pressedItem = -2;
        isHorizontal = false;
        border = false;
        controle = false;
        controle1 = true;
        backColor = 0xcafeba;
        backHighColor = 0xdafeca;
        fontColor = 16384;
        fontHighColor = 47872;
        shadowColor = -1;
        shadowHighColor = -1;
        buttonType = 1;
        fonte = "";
        align = "left";
        status = "link";
        delimiter = ",";
        tamFonte = 12;
        modoFonte = 0;
        largura = 0;
    }

    /***************************************************************
    Descriptografa mensagem que aparecer no Status BAR do navegador
    ****************************************************************/
    String unCript(String s)
    {
        char ac[] = s.toCharArray();
        for(int i = 0; i < ac.length; i++)
            ac[i] = (char)(ac[i] - i % 3 - 1);

        return new String(ac);
    }

    /****************************************************
    Verifica se possui uma string iniciada por javascript
    *****************************************************/
    public void checkJavaScript(String s)
    {
        s = getParameter(s);
        if(s != null)
        {
            if(s.startsWith("javascript:"))
                s = s.substring(11);
        }
    }

    /*************
    Desenha o menu
    **************/
    public void criaMenu()
    {
        count = 0;

       	/*****************************
       	Recupera parmetro "backColor"
       	******************************/
       	param = getParameter("backColor");
        if(param != null)
        {
            backColor = Integer.parseInt(param, 16);
            backHighColor = backColor;
        }

        /*****************************
		Recupera parmetro "fontColor"
       	******************************/
        param = getParameter("fontColor");
        if(param != null)
        {
            fontColor = Integer.parseInt(param, 16);
            fontHighColor = fontColor;
        }
        width = getSize().width;
        height = getSize().height;
        img = createImage(width, height);
        graph = img.getGraphics();
        graph.setFont(new Font("Arial", 0, 11));
        graph.setColor(new Color(backColor));
        graph.fillRect(0, 0, width, height);
        graph.setColor(new Color(fontColor));
        graph.drawString("Carregando ...", 10, 15);
        design();

        /***************************
		Recupera parmetro "backPic"
       	****************************/
        if(getParameter("backPic") != null)
        {
            Image image = retImage(getParameter("backPic"));
            largura = 0;
            if(image != null)
            {
                img1 = createImage(width, height);
                Graphics g = img1.getGraphics();
                g.setColor(new Color(backColor));
                g.fillRect(0, 0, width, height);
                for(int i = 0; i < width; i += image.getWidth(this))
                {
                    for(int k = 0; k < height; k += image.getHeight(this))
                        g.drawImage(image, i, k, this);

                }

                graph.drawImage(img1, 0, 0, this);
                graph.drawString("Carregando ...", 10, 15);
                design();
            }
        }
        /*****************************
		Recupera parmetro "buttonType"
       	******************************/
        param = getParameter("buttonType");
        if(param != null)
            buttonType = Integer.parseInt(param);

        /*******************************
		Recupera parmetro "pressedItem"
       	********************************/
        param = getParameter("pressedItem");
        if(param != null)
            pressedItem = Integer.parseInt(param) - 1;

        /********************************
		Recupera parmetro "backHighColor"
       	*********************************/
        param = getParameter("backHighColor");
        if(param != null)
            backHighColor = Integer.parseInt(param, 16);

        /********************************
		Recupera parmetro "fontHighColor"
       	*********************************/
        param = getParameter("fontHighColor");
        if(param != null)
            fontHighColor = Integer.parseInt(param, 16);

        /******************************
		Recupera parmetro "shadowColor"
       	*******************************/
        param = getParameter("shadowColor");
        if(param != null)
            shadowColor = Integer.parseInt(param, 16);

        /**********************************
		Recupera parmetro "shadowHighColor"
       	***********************************/
        param = getParameter("shadowHighColor");
        if(param != null)
            shadowHighColor = Integer.parseInt(param, 16);

        backHColor = (backHighColor & 0xff0000) >> 16;
        backHC = (backHighColor & 0xff00) >> 8;
        backHColorMask = backHighColor & 0xff;
        backColorMaskResult = (retColor((backHColor * 2) / 3) << 16) + (retColor((backHC * 2) / 3) << 8) + retColor((backHColorMask * 2) / 3);
        backHColorResult = (retColor(((255 - backHColor) / 3) * 2 + backHColor) << 16) + (retColor(((255 - backHC) / 3) * 2 + backHC) << 8) + retColor(((255 - backHColorMask) / 3) * 2 + backHColorMask);
        backHColor = (backColor & 0xff0000) >> 16;
        backHC = (backColor & 0xff00) >> 8;
        backHColorMask = backColor & 0xff;
        backHCResult = (retColor((backHColor * 2) / 3) << 16) + (retColor((backHC * 2) / 3) << 8) + retColor((backHColorMask * 2) / 3);
        backColorResult = (retColor(((255 - backHColor) / 3) * 2 + backHColor) << 16) + (retColor(((255 - backHC) / 3) * 2 + backHC) << 8) + retColor(((255 - backHColorMask) / 3) * 2 + backHColorMask);

        /***********************************************************
		Recupera parmetro "isHorizontal" - Define a direo do menu
       	************************************************************/
        param = getParameter("isHorizontal");
        if(param != null && param.equalsIgnoreCase("true"))
            isHorizontal = true;

        /****************************
		Recupera parmetro "3DBorder"
       	*****************************/
        param = getParameter("3DBorder");
        if(param != null && param.equalsIgnoreCase("true"))
            border = true;
        if(buttonType == 0 && border)
            offsetY = 2;

        /*****************************
		Recupera parmetro "alignText"
       	******************************/
        param = getParameter("alignText");
        if(param != null)
            align = param;

        /**************************
		Recupera parmetro "status"
       	***************************/
        param = getParameter("status");
        if(param != null)
            status = param;

        /********************************
		Recupera parmetro "statusString"
       	*********************************/
        param = getParameter("statusString");
        if(param != null)
            statusString = param;
        param = getDocumentBase().getHost();

        /************************
		Recupera parmetro "font"
       	*************************/
        param = getParameter("font");
        if(param != null)
        {
            StringTokenizer stringtokenizer = new StringTokenizer(param, ",");
            fonte = stringtokenizer.nextToken();
            tamFonte = Integer.parseInt(stringtokenizer.nextToken());
            modoFonte = Integer.parseInt(stringtokenizer.nextToken());
        }
        graph.setFont(new Font(fonte, modoFonte, tamFonte));

        /*****************************
		Recupera parmetro "delimiter"
       	******************************/
        param = getParameter("delimiter");
        if(param != null)
            delimiter = param;

        /************************************************************************************
		Recupera parmetro "menuItemsFile" - se presente determina qual arquivo deve ser lido
       	*************************************************************************************/
        param = getParameter("menuItemsFile");
        if(param != null)
            try
            {
                URL url = new URL(getCodeBase(), param);
                param = "";
                BufferedReader d = new BufferedReader(new InputStreamReader(url.openStream()));
                String s;
                while((s = d.readLine()) != null)
                    param += s;
            }
            catch(Exception ex) { }
        else
        	/*****************************
			Recupera parmetro "menuItems"
       		******************************/
            param = getParameter("menuItems");

        param = param.substring(0, param.lastIndexOf("}"));
        StringTokenizer stringtokenizer1 = new StringTokenizer(param, "}");
        count = stringtokenizer1.countTokens();
        while(stringtokenizer1.hasMoreTokens())
        {
            String s1 = stringtokenizer1.nextToken();

            s1 = s1.substring(s1.indexOf("{") + 1).trim();
            if(s1.startsWith("|"))
                count--;
        }
        posXA = new int[count];
        posYA = new int[count];
        posXB = new int[count];
        posYB = new int[count];
        parametro = new String[count];
        page = new URL[count];
        conteudo = new String[count];
        vImg = new Image[count];
        int j = 0;
        int l = 0;
        for(StringTokenizer stringtokenizer2 = new StringTokenizer(param, "}"); stringtokenizer2.hasMoreTokens();)
        {
            param = stringtokenizer2.nextToken();
            param = param.substring(param.indexOf("{") + 1);
            StringTokenizer stringtokenizer3 = new StringTokenizer(param, delimiter);
            param = new String(stringtokenizer3.nextToken());

            if(!param.startsWith("|"))
            {
                parametro[j] = param;
                if(parametro[j].equals("_"))
                    parametro[j] = "";
                if(parametro[j].trim().equals("-"))
                {
                    l++;
                    j++;
                } else
                if(!stringtokenizer3.hasMoreTokens())
                {
                    conteudo[j] = "_";
                    j++;
                } else
                {
                    if(stringtokenizer3.countTokens() == 1)
                    {
                        vImg[j] = retImage(stringtokenizer3.nextToken());
                        conteudo[j] = "_";
                    } else
                    {
                        param = stringtokenizer3.nextToken();
                        if(!param.startsWith("javascript:"))
                        {
                            try
                            {
                               page[j] = new URL(getCodeBase(), param);
                            }
                            catch(Exception ex) { }
                            conteudo[j] = new String(stringtokenizer3.nextToken());
                        } else
                        {
                            conteudo[j] = new String(param);
                            param = stringtokenizer3.nextToken();
                        }
                        if(stringtokenizer3.hasMoreTokens())
                            vImg[j] = retImage(stringtokenizer3.nextToken());
                    }
                    j++;
                }

            }
        }

        if(!isHorizontal)
            altura = (height - l * 8 - offsetY * 2) / (count - l);
        else
            altura = height - offsetY * 2;
        posicao = (altura / 2 + tamFonte / 2) - 1;
        offsetX = 0;
        if(isHorizontal)
        {
            for(int i1 = 0; i1 < count; i1++)
                if(!parametro[i1].trim().equals("-"))
                {
                    posXB[i1] = graph.getFontMetrics().stringWidth(parametro[i1]);
                    if(vImg[i1] != null)
                        posXB[i1] += vImg[i1].getWidth(this) + 3;
                    offsetX += posXB[i1];
                }

            posXA[0] = offsetY;
            for(int k1 = 0; k1 < count; k1++)
            {
                posYB[k1] = (width - 7 * l - offsetX) / (count - l) / 2;
                if(parametro[k1].trim().equals("-"))
                    posXB[k1] = 7;
                else
                    posXB[k1] = posXB[k1] + posYB[k1] * 2;
                if(k1 > 0)
                    posXA[k1] = posXA[k1 - 1] + posXB[k1 - 1];
                posYA[k1] = offsetY;
                if(vImg[k1] != null)
                    posYB[k1] += vImg[k1].getWidth(this) + 3;

                desenhaMenu(k1);
                design();
            }

            posXB[count - 1] = width - posXA[count - 1] - offsetY;
        } else
        {
            offsetX = offsetY;
            for(int j1 = 0; j1 < count; j1++)
            {
                posXA[j1] = offsetY;
                posXB[j1] = width - offsetY * 2;
                if(parametro[j1].trim().equals("-"))
                {
                    posYA[j1] = offsetX;
                    offsetX += 8;
                } else
                {
                    posYA[j1] = offsetX;
                    offsetX += altura;
                    if(align.equalsIgnoreCase("center"))
                        posYB[j1] = width / 2 - graph.getFontMetrics().stringWidth(parametro[j1]) / 2;
                    if(align.equalsIgnoreCase("left"))
                        posYB[j1] = tamFonte / 2 + largura + 3;
                    if(align.equalsIgnoreCase("right"))
                        posYB[j1] = width - graph.getFontMetrics().stringWidth(parametro[j1]) - tamFonte / 2;
                    desenhaMenu(j1);
                    design();
                }
            }

        }
        Object obj;
        for(obj = this; obj != null && !(obj instanceof Frame); obj = ((Component) (obj)).getParent());
        frm = (Frame)obj;
    }

    /*********************************
    Retorna valores vlidos para cores
    **********************************/
    int retColor(int i)
    {
        if(i > 255)
            return 255;
        if(i < 0)
            return 0;
        else
            return i;
    }

    /**********************
    Desenha borda para Menu
    ***********************/
    public void desenhaBorda(int i, int j, int k)
    {
        int l = backColorResult;
        int i1 = backHCResult;
        if(i == -1)
        {
            graph.setColor(new Color(l));
            graph.drawLine(0, 0, width, 0);
            graph.drawLine(0, 0, 0, height);
            graph.setColor(new Color(i1));
            graph.drawLine(width - 1, height - 1, width - 1, 0);
            graph.drawLine(width - 1, height - 1, 1, height - 1);
            return;
        }
        if(k != 0)
        {
            l = backHColorResult;
            i1 = backColorMaskResult;
        }
        switch(j)
        {
        default:
            graph.setColor(new Color(l));
            graph.drawLine(posXA[i], posYA[i], (posXA[i] + posXB[i]) - 1, posYA[i]);
            graph.drawLine(posXA[i], posYA[i], posXA[i], (posYA[i] + altura) - 1);
            graph.setColor(new Color(i1));
            graph.drawLine((posXA[i] + posXB[i]) - 1, (posYA[i] + altura) - 1, (posXA[i] + posXB[i]) - 1, posYA[i]);
            graph.drawLine((posXA[i] + posXB[i]) - 1, (posYA[i] + altura) - 1, posXA[i] + 1, (posYA[i] + altura) - 1);
            break;

        case 1: // '\001'
            graph.setColor(new Color(i1));
            graph.drawLine(posXA[i], posYA[i], (posXA[i] + posXB[i]) - 1, posYA[i]);
            graph.drawLine(posXA[i], posYA[i], posXA[i], (posYA[i] + altura) - 1);
            graph.setColor(new Color(l));
            graph.drawLine((posXA[i] + posXB[i]) - 1, (posYA[i] + altura) - 1, (posXA[i] + posXB[i]) - 1, posYA[i]);
            graph.drawLine((posXA[i] + posXB[i]) - 1, (posYA[i] + altura) - 1, posXA[i] + 1, (posYA[i] + altura) - 1);
            break;

        case 2: // '\002'
            graph.setColor(new Color(l));
            graph.drawLine(posXA[i] + 1, posYA[i] + 1, (posXA[i] + posXB[i]) - 2, posYA[i] + 1);
            graph.drawLine(posXA[i] + 1, posYA[i] + 1, posXA[i] + 1, (posYA[i] + altura) - 2);
            graph.setColor(new Color(0));
            graph.drawLine((posXA[i] + posXB[i]) - 1, (posYA[i] + altura) - 1, (posXA[i] + posXB[i]) - 1, posYA[i]);
            graph.drawLine((posXA[i] + posXB[i]) - 1, (posYA[i] + altura) - 1, posXA[i] + 1, (posYA[i] + altura) - 1);
            graph.setColor(new Color(i1));
            graph.drawLine((posXA[i] + posXB[i]) - 2, (posYA[i] + altura) - 2, (posXA[i] + posXB[i]) - 2, posYA[i] + 1);
            graph.drawLine((posXA[i] + posXB[i]) - 2, (posYA[i] + altura) - 2, posXA[i] + 2, (posYA[i] + altura) - 2);
            break;

        case 3: // '\003'
            graph.setColor(new Color(i1));
            graph.drawLine(posXA[i] + 1, posYA[i] + 1, (posXA[i] + posXB[i]) - 2, posYA[i] + 1);
            graph.drawLine(posXA[i] + 1, posYA[i] + 1, posXA[i] + 1, (posYA[i] + altura) - 2);
            graph.setColor(new Color(0));
            graph.drawLine(posXA[i], posYA[i], (posXA[i] + posXB[i]) - 1, posYA[i]);
            graph.drawLine(posXA[i], posYA[i], posXA[i], (posYA[i] + altura) - 1);
            graph.setColor(new Color(l));
            graph.drawLine((posXA[i] + posXB[i]) - 2, (posYA[i] + altura) - 2, (posXA[i] + posXB[i]) - 2, posYA[i] + 1);
            graph.setColor(new Color(l));
            graph.drawLine((posXA[i] + posXB[i]) - 1, (posYA[i] + altura) - 1, (posXA[i] + posXB[i]) - 1, posYA[i]);
            graph.drawLine((posXA[i] + posXB[i]) - 1, (posYA[i] + altura) - 1, posXA[i] + 1, (posYA[i] + altura) - 1);
            break;
        }
    }

    /**********************************************
    Define a direo na qual o menu ser construdo
    ***********************************************/
    public void defineDirecao(int i, int j)
    {
        if(vImg[i] == null)
            return;
        if(isHorizontal)
            graph.drawImage(vImg[i], (posXA[i] + posYB[i]) - vImg[i].getWidth(this) - 3, posYA[i] + (altura - vImg[i].getHeight(this)) / 2 + j, this);
        else
            graph.drawImage(vImg[i], posXA[i] + 3, posYA[i] + (altura - vImg[i].getHeight(this)) / 2 + j, this);
    }

    /***********
    Desenha tela
    ************/
    public synchronized void design()
    {
        if(img == null)
            return;
        if(controle)
        {
            graph.setColor(new Color(backColor));
            graph.fillRect(0, 0, width, height);

            if(img1 != null)
    	    	graph.drawImage(img1, 0, 0, this);

	        for(int i = 0; i < count; i++)
	       		desenhaMenu(i);

            if(border)
            	desenhaBorda(-1, 0, 0);
        }
        getGraphics().drawImage(img, 0, 0, this);
    }

    public Image retImage(String s)
    {
        Image image = null;
        MediaTracker mediatracker = new MediaTracker(this);
        try
        {
            image = getImage(getCodeBase(), s);
            mediatracker.addImage(image, 0);
            mediatracker.waitForID(0);
        }
        catch(Exception ex)
        {
            return null;
        }
        if(mediatracker.isErrorID(0))
        {
            return null;
        } else
        {
            largura = image.getWidth(this) <= largura ? largura : image.getWidth(this);
            return image;
        }
    }

    /**************************
    Desenha o separador do menu
    ***************************/
    public void desenhaSeparador(int i)
    {
        byte byte0 = 3;
        if(isHorizontal)
        {
            graph.setColor(new Color(backHCResult));
            graph.drawLine(posXA[i] + byte0, posYA[i] + byte0, posXA[i] + byte0, (posYA[i] + altura) - byte0 - 1);
            graph.setColor(new Color(backColorResult));
            graph.drawLine(posXA[i] + byte0 + 1, posYA[i] + byte0, posXA[i] + byte0 + 1, (posYA[i] + altura) - byte0 - 1);
            graph.drawLine(posXA[i] + byte0, (posYA[i] + altura) - byte0 - 1, posXA[i] + byte0 + 1, (posYA[i] + altura) - byte0 - 1);
        } else
        {
            graph.setColor(new Color(backHCResult));
            graph.drawLine(posXA[i] + byte0, posYA[i] + byte0, (posXA[i] + posXB[i]) - byte0 - 1, posYA[i] + byte0);
            graph.setColor(new Color(backColorResult));
            graph.drawLine(posXA[i] + byte0, posYA[i] + byte0 + 1, (posXA[i] + posXB[i]) - byte0 - 1, posYA[i] + byte0 + 1);
            graph.drawLine((posXA[i] + posXB[i]) - byte0 - 1, posYA[i] + byte0 + 1, (posXA[i] + posXB[i]) - byte0 - 1, posYA[i] + byte0);
        }
    }

    /**************
    Desenha o boto
    ***************/
    public int desenhaBotao(int i, int j)
    {
        for(int k = 0; k < count; k++)
            if(!parametro[k].trim().equals("-"))
            {
                Rectangle rectangle = new Rectangle(posXA[k], posYA[k], posXB[k], altura);
                if(rectangle.contains(i, j))
                    return k;
            }

        return -1;
    }
    /*************
    Desenha o Titulo
    **************/
    public void desenhaTitulo(int i)
    {
        int j = 0;
        int k = 0;
        int l = backColor;
        int i1 = fontColor;
        int j1 = shadowColor;

        if(indice == i)
        {
            j = 1;
            k = indice1;
            l = backColor;
            i1 = fontColor;
            j1 = shadowColor;
        }

        if(img1 == null)
        {
            graph.setColor(new Color(l));
            graph.fillRect(posXA[i], posYA[i], posXB[i], altura);
        }

        if(j1 != -1)
        {
            graph.setColor(new Color(j1));
            graph.drawString(parametro[i], posXA[i] + posYB[i] + 1, posYA[i] + posicao + 1);
        }

        graph.setColor(new Color(i1));

        graph.drawString(parametro[i], posXA[i] + posYB[i], posYA[i] + posicao + k);

        if(indice == i || pressedItem == i)
            switch(buttonType)
            {
            	case 1: // '\001'
            	case 2: // '\002'
            	    desenhaBorda(i, k, j);
            	    break;

            	case 3: // '\003'
            	case 4: // '\004'
            	case 5: // '\005'
            	    desenhaBorda(i, 2 + k, j);
            	    break;
            }
        else
            switch(buttonType)
            {
            	case 2: // '\002'
            	case 5: // '\005'
            	    desenhaBorda(i, 0, 0);
            	    break;

            	case 4: // '\004'
            	    desenhaBorda(i, 2, 0);
            	    break;
            }
        defineDirecao(i, k);
    }

    /*************
    Desenha o menu
    **************/
    public void desenhaMenu(int i)
    {
        if(parametro[i].trim().equals("-"))
        {
            desenhaSeparador(i);
            return;
        }

        if(conteudo[i].trim().equals("#"))
        {
        	desenhaTitulo(i);
        	return;
		}

        int j = 0;
        int k = 0;
        int l = backColor;
        int i1 = fontColor;
        int j1 = shadowColor;
        if(indice == i)
        {
            j = 1;
            k = indice1;
            l = backHighColor;
            i1 = fontHighColor;
            j1 = shadowHighColor;
        }
        if(pressedItem == i)
        {
            j = 1;
            k = 1;
            l = backHighColor;
            i1 = fontHighColor;
            j1 = shadowHighColor;
        }
        if(img1 == null)
        {
            graph.setColor(new Color(l));
            graph.fillRect(posXA[i], posYA[i], posXB[i], altura);
        }

        if(j1 != -1)
        {
            graph.setColor(new Color(j1));
            graph.drawString(parametro[i], posXA[i] + posYB[i] + 1, posYA[i] + posicao + 1);
        }
        if(conteudo[i].equals("_"))
        {
            graph.setColor(new Color(backColorResult));
            graph.drawString(parametro[i], posXA[i] + posYB[i] + 1, posYA[i] + posicao + 1);
        }

        graph.setColor(new Color(i1));
        if(conteudo[i].equals("_"))
            graph.setColor(new Color(backHCResult));
        graph.drawString(parametro[i], posXA[i] + posYB[i], posYA[i] + posicao + k);
        if(indice == i || pressedItem == i)
            switch(buttonType)
            {
            case 1: // '\001'
            case 2: // '\002'
                desenhaBorda(i, k, j);
                break;

            case 3: // '\003'
            case 4: // '\004'
            case 5: // '\005'
                desenhaBorda(i, 2 + k, j);
                break;
            }
        else
            switch(buttonType)
            {
            case 2: // '\002'
            case 5: // '\005'
                desenhaBorda(i, 0, 0);
                break;

            case 4: // '\004'
                desenhaBorda(i, 2, 0);
                break;
            }
        defineDirecao(i, k);
    }

    /************************
    Trata os eventos do mouse
    *************************/
    public boolean handleEvent(Event event)
    {

        if(!controle)
            return true;
        int i = desenhaBotao(event.x, event.y);
        if(i == -1 || conteudo[i].equals("_") || pressedItem == i)
            i = -1;
        try
        {
            if(i == -1 || event.id == 505)
            {
                indice = -1;
                if(frm != null)
                    frm.setCursor(0);
                design();
                return true;
            }
            if(event.id == 503)
            {
                if(!controle1)
                    return true;
                controle1 = false;
                if(i != indice)
                {
                    if(frm != null)
                        frm.setCursor(12);
                    indice1 = 0;
                    indice = i;
                    design();

                   	if(statusString == null)
                    {
                        /*********************************
                        Mouse passando por sobre os botes
                        **********************************/
                        if(status.equalsIgnoreCase("link") && page[i] != null)
                        {
                            showStatus(msg[i].trim());
   						}
                        else
                        {
                            showStatus(parametro[i].trim());
					 	}
                    } else
                    {
						showStatus(statusString);
                    }
                }
            }
            if(event.id == 501)
            {

				if( conteudo[i].trim().equals( "#" ) )
					return true;

                if(!controle1)
                    return true;
                controle1 = false;
                indice = i;
                indice1 = 1;
                if(pressedItem > -2)
                    pressedItem = i;
                design();

                if(!conteudo[i].startsWith("javascript:"))
                {
                    if(page[i] != null)
                        getAppletContext().showDocument(page[i], conteudo[i]);
                } else
                {
                    checkJavaScript(conteudo[i]);
                }
            }
        }
        catch(Throwable ex) { }
        controle1 = true;
        return true;
    }

    public void paint(Graphics g)
    {
		update(g);
        design();
    }

    public void run()
    {
        do
        {
            if(!controle)
            {
                criaMenu();
                controle = true;
                design();
            }
            try
            {
                Thread.sleep(200L);
                design();
            }
            catch(InterruptedException ex) { }
        } while(true);
    }

    public void start()
    {
        if(thread == null)
        {
            thread = new Thread(this);
            thread.start();
        }
    }

    public void stop()
    {
        if(thread != null)
        {
            thread = null;
        }
    }

	public void update(Graphics g)
	{
		Dimension d = getSize();
	}

	public Insets getInsets()
	{
		return new Insets(10,10,10,10);
	}
}