/****************************************
Classe responsvel para o registro do Log
****************************************/

import java.io.*;

public class MLog
{
	private String projeto;
	private DataOutputStream output;

	// Construtor
	public MLog(String proj) throws Exception
	{
		projeto = proj.trim().toUpperCase();

		System.out.println("projeto="+projeto);
		if ( projeto.length() == 0)
		{
			throw new Exception("Lenght of project is null");
		}

		//try
		//{
		//	gravaMsg("teste");
		//}
		//catch (IOException ioe)
		//{
		//	System.out.println(ioe.toString());
		//}
	}

	// Inserir mensagem
	public void gravaMsg(String msg) throws IOException
	{
		// Consiste o tamanho da mensagem
		if ( msg.length() == 0)
		{
			throw new IOException("Lenght of message is null");
		}

		try
		{
			openOutputFile();
			addText(msg);
		}
		catch( IOException e)
		{
			throw e;
		}
	}

	// Abre o arquivo
	private void openOutputFile() throws IOException
	{
		String fileName = projeto + ".log";

		System.out.println(fileName);
		try
		{
			output = new DataOutputStream( new FileOutputStream( fileName, true ) );
		}
		catch ( IOException e )
		{
			throw e;
		}
	}

	// Adiciona dados no arquivo
	private void addText(String xMsg) throws IOException
	{
		try
		{
			output.writeBytes(xMsg);
			output.flush();
		}
		catch ( IOException e )
		{
			throw e;
		}
	}

	// Fecha o arquivo
	private void closeOutputFile() throws IOException
	{
		try
		{
			output.close();
		}
		catch ( IOException e )
		{
			throw e;
		}
	}

	//public static void main(String[] args)
	//{
	//	try
	//	{
	//		Log t = new Log("xxx");
	//		t.gravaMsg("eu...\n");
	//	}
	//	catch (Exception e) {}
	//
	//	System.out.println("teste");
	//}

}
