import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.util.Calendar;
//import java.util.Vector;
import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

class Teste
{
	public Teste() throws Exception
	{
		SimpleDateFormat formatter;
		DateFormat df;
		Calendar cal;
		int dia;

		try
		{
			formatter = new SimpleDateFormat("yyyyMMdd");
			df = formatter.getDateInstance();
			cal = Calendar.getInstance();
		}
		catch (Exception e)
		{
			System.out.println(e.toString());
			throw e;
		}

		int myDia[] = new int[8];
		int mySem[] = new int[5];
		int myMes[] = new int[5];
		Date hoje = new Date(System.currentTimeMillis());

		try
		{
			// Obtm as datas da ltima semana
			cal.setTime(hoje);
			dia = cal.get(Calendar.DAY_OF_WEEK);
			for(;dia > 1; dia--)
			{
				cal.add(Calendar.DATE, -1);
			}

			for(int idx=0; idx < 8; idx++)
			{
				Integer aux =new Integer(formatter.format(cal.getTime()));
				myDia[idx] = aux.intValue();
				System.out.println("Dias.="+myDia[idx]);
				cal.add(Calendar.DATE, 1);
			}

			// Obtm os datas das ltimas 4 semanas
			cal.setTime(hoje);
			dia = cal.get(Calendar.DAY_OF_WEEK);
			for(;dia > 1; dia--)
			{
				cal.add(Calendar.DATE, -1);
			}

			for(int idx=0; idx < 5; idx++)
			{
				Integer aux =new Integer(formatter.format(cal.getTime()));
				mySem[idx] = aux.intValue();
				System.out.println("Semana="+mySem[idx]);
				cal.add(Calendar.WEEK_OF_MONTH, -1);
			}

			// Obtm as datas dos ltimos 4 meses
			cal.setTime(hoje);
			cal.set(Calendar.DAY_OF_MONTH, 1);
			for(int idx=0; idx < 5; idx++)
			{
				Integer aux =new Integer(formatter.format(cal.getTime()));
				myMes[idx] = aux.intValue();
				System.out.println("Meses.="+myMes[idx]);
				cal.add(Calendar.MONTH, -1);
			}
		}
		catch (Exception e)
		{
			System.out.println(e.toString());
		}
	}

	public static void main(String args[])
	{
		try
		{
			Teste apl = new Teste();
		}
		catch (Exception e) {};
	}
}

