
import java.awt.Color;
import java.awt.Font;

public class Parametro
{
	public static final int remotePort=5001;				// Mquina pps2a
	public static final String remoteHost="10.254.1.131";
	//public static final int remotePort=5002;				// Mquina pps2
	//public static final String remoteHost="10.254.1.2";
	public static final String logFile="middleware.log";

	public static final String HOME_HTTP="http://localhost:8080/middleware/servlet/";
	public static final String HOME_MIDDLEWARE="HTTPMiddleWare";

	public static final Color BACKCOLOR = new Color(0,113,183);
	public static final Color FORECOLOR = Color.white;
	public static final Color FORECOLOR_TEXT = Color.black;
	public static final Color BACKCOLOR_TEXT = Color.white;
	private static final Font FONTE = new Font("Arial",Font.PLAIN + Font.BOLD,10);
	public static final Font FONTE0 = new Font("Arial", Font.BOLD + Font.PLAIN, 10);
	public static final Font FONTE1 = new Font("Arial", Font.BOLD, 14);
	public static final Font FONTE2 = new Font("Arial", Font.PLAIN, 12);
	public static final Font FONTE3 = new Font("Arial", Font.BOLD + Font.PLAIN, 12);

	public static String get_logFile()
	{
		return logFile;
	}

	public static int get_remotePort()
	{
		return remotePort;
	}

	public static String get_remoteHost()
	{
		return remoteHost;
	}

	public static String get_Middleware()
	{
		return HOME_HTTP + HOME_MIDDLEWARE;
	}

	public static Color get_BackColor()
	{
		return BACKCOLOR;
	}

	public static Color get_ForeColor()
	{
		return FORECOLOR;
	}

	public static Color getForeColorText()
	{
		return FORECOLOR_TEXT;
	}

	public static Color getBackColorText()
	{
		return BACKCOLOR_TEXT;
	}

	public static Font get_Fonte()
	{
		return FONTE;
	}

	public static Font getFontePequena()
	{
		return FONTE0;
	}

	public static Font getFonteMedia()
	{
		return FONTE3;
	}

	public static Font getFonteGrande()
	{
		return FONTE1;
	}

	// Inicia string no formato XML
	public String xml_ini()
	{
		return ("<?xml version='1.0' encoding='ISO-8859-1'?>\n");
	}

	// Fabrica string no formato XML
	public String xml_str(String tag, String val)
	{
		String aux =	"<" + tag.toString().trim() + ">" + val.toString().trim() +
						"</" + tag.toString().trim() + ">\n";
		return aux;
	}

	// Fabrica string no formato XML
	public String xml_str(String tag, int val)
	{
		Integer num = new Integer(val);

		String aux =	"<" + tag.toString().trim() + ">" + num.toString() +
						"</" + tag.toString().trim() + ">\n";
		return aux;
	}

	// Fabrica string da transao no formato XML
	public String xml_transac(int val)
	{
		Integer num = new Integer(val);
		return (xml_str("TRANSACAO", num.toString()));
	}

	// Devolve string formatado em XML
	public String xml_get(String buffer, String tag)
	{
		String tag1 = "<" + tag.toString().trim() + ">";
		String tag2 = "</" + tag.toString().trim() + ">";
		String resp;
		int pos1, pos2;

		resp = "";
		pos1 = buffer.indexOf(tag1);
		pos2 = buffer.indexOf(tag2);

		if(pos1 != -1)
		{
			pos1 = pos1 + tag1.length();
			if (pos2 != -1)
			{
				if(pos1 < pos2)
				{
					resp = buffer.substring(pos1,pos2);
				}
			}
		}

		if(resp.length() > 0)
			return resp;
		else
			return null;
	}

	/*****************
	Log de ocorrencias
	******************/
	public void debug(String msg)
	{
		try
		{
			System.out.println(">>> "+msg);
			if (msg.length() > 0)
			{
				MLog l = new MLog( get_logFile() );
				l.gravaMsg(msg + "\n");
				l=null;
			}
		}
		catch (Exception e)
		{
			System.out.println(e.toString());
		}
	}
}
