import java.applet.*;
import java.awt.*;
import java.awt.List;

public class Info extends Applet
{
	private Dimension size;
	private Informacao informacao;
	private String codLoja[], codEstado[], user, username;
	private List lstLoja, lstEstado, lstMail;
	private int perfil, transac;
	private LogoUsuario logousuario;
	public static final Parametro param = new Parametro();
	private static final String GIF = "telespc.gif";
	private Image image;

	public void init()
	{
		String aux;

		size = getSize();
		aux = getParameter("perfil");
		perfil = (aux == null) ? 46 : Integer.parseInt(aux);

		aux = getParameter("transac");
		transac = (aux == null) ? 1 : Integer.parseInt(aux);

		// Obtem lista de lojas existentes
		obtLojas();

		// Obtem lista de estados vlidos para o celular
		obtEstados();

		// Obtem lista de Mails
		obtMails();

		/********************
		Obtem user e username
		*********************/
		user = getParameter("userid");
		username = getParameter("username");
		username = username.replace('_',' ');

		/**********************************
		Monta o Logotipo com usurio e nome
		***********************************/
		Image image = getImage(getCodeBase(), param.LOGO);
		logousuario = new LogoUsuario(user,username, image);

		/***********************
		Obtem usuario e username
		************************/
		informacao = new Informacao( 	size.width - 2,
										size.height - 260,
										getAppletContext(),
										perfil,
										lstLoja,
										lstEstado,
										lstMail,
										transac,
										codLoja,
										codEstado );

		/******************
		Ttulo do relatrio
		*******************/
		Titulo titulo = new Titulo(param.get_Titulo(informacao.getTransaction()),20,20);

		setLayout(new BorderLayout());
		add(titulo,BorderLayout.NORTH);
		add(logousuario, BorderLayout.WEST);
		add(informacao, BorderLayout.CENTER);

		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
	}

	/**********
	Obtm lojas
	***********/
	void obtLojas()
	{
		int pos, tam, qtd;
		String cod, descr;
		String lojas = getParameter("param1");

		try
		{
			tam=lojas.length();

			/********************
			Obtem qtd. de lojaEst
			*********************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring(lojas, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring(lojas, pos);
				pos=pos+descr.length()+1;
				if (pos >= tam) break;
			}

			/**********
			Cria arrays
			***********/
			codLoja = new String[qtd+1];
			lstLoja = new List();

			/********************
			Obtem qtd. de lojaEst
			*********************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring(lojas, pos);
				pos=pos+cod.length()+1;

				descr = param.getSubstring(lojas, pos);
				pos=pos+descr.length()+1;

				codLoja[qtd] = cod;
				lstLoja.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/************
	Obtm Estados
	*************/
	void obtEstados()
	{
		int pos, tam, qtd;
		String cod, descr;
		String estados = getParameter("param2");

		try
		{
			tam=estados.length();

			// Obtem qtd. de estados
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring(estados, pos);
				pos=pos+cod.length()+1;
				descr = param.getSubstring(estados, pos);
				pos=pos+descr.length()+1;

				if (pos >= tam) break;
			}

			// Cria arrays
			codEstado  	= new String[qtd+1];
			lstEstado	= new List();

			/**********************
			Obtem qtd. de cbEstados
			***********************/
			for(pos=0, qtd=0;; qtd++)
			{
				cod = param.getSubstring(estados, pos);
				pos=pos+cod.length()+1;

				descr = param.getSubstring(estados, pos);
				pos=pos+descr.length()+1;

				codEstado[qtd] = cod;
				lstEstado.add(descr.replace('_',' '));

				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}

	/**********
	Obtm Mail
	***********/
	void obtMails()
	{
		int pos, tam;
		String descr;

		lstMail = new List();
		String parametro = getParameter("param3");

		try
		{
			tam=parametro.length();
			pos=0;
			while(true)
			{
				descr = param.getSubstring(parametro, pos);
				pos=pos+descr.length()+1;
				lstMail.add(descr);
				if (pos >= tam) break;
			}
		}
		catch( Exception e)
		{
			System.out.println( e.toString() );
		}
	}
}
