import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.Applet;
import java.io.PrintStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.net.*;
import java.util.Vector;

public class ClienteInformacao extends Panel implements KeyListener, ItemListener
{
	private TextField txtNome;
	private TextField txtCEP;
	private TextField txtLogradouro;
	private TextField txtCompl1;
	private TextField txtCompl2;
	private TextField txtUF;
	private TextField txtNum;
	private TextField txtBairro;
	private TextField txtCidade;
	private TextField txtDoc1;
	private TextField txtDoc2;
	private TextField txtEmissao;
	private TextField txtOrgaoExp;
	private TextField txtContato;
	private TextField txtTelef;
	private TextField txtAtivacao;
	private TextField txtEmail;
	private Choice  choEstado, choHistorico, choTipo,choDoc1,choDoc2;

	private static final CheckString clsCheckString = new CheckString();

	private ButtonGroup cbg2;
	private JRadioButton rdbMasc,rdbFem,rdbFisica,rdbJuridica;
	private List lstLogradouro, lstEstado, lstUF, lstHistorico,lstDoc1,lstDoc2;
	private String[] codLogradouro, codEstado, codUF, codHistorico,codDoc1,codDoc2;
	private String focus;
	private Vector descLogradouro,descUF;

	private MyPoupUp myPoupUp;

	private Button bttCEP,bttEndereco;

	private Cadastro clsCadastro;

	private Parametro param = new Parametro();

	public ClienteInformacao(	Cadastro pCadastro,List lstLogradouro,
					List lstEstado, List lstHistorico,List lstDoc1,List lstDoc2,
					String[] codLogradouro, String[] codEstado, String[] codHistorico,
					String[] codDoc1,String[] codDoc2 )
	{

		clsCadastro = pCadastro;

		this.lstLogradouro = lstLogradouro;
		this.lstEstado = lstEstado;
		this.lstUF = lstEstado;
		this.lstHistorico = lstHistorico;
		this.lstDoc1 = lstDoc1;
		this.lstDoc2 = lstDoc2;
		this.codLogradouro = codLogradouro;
		this.codEstado = codEstado;
		this.codUF = codEstado;
		this.codHistorico = codHistorico;
		this.codDoc1 = codDoc1;
		this.codDoc2 = codDoc2;

		descLogradouro = new Vector( 1,1 );
		descUF = new Vector( 1,1 );

		focus=".";

		myPoupUp = new MyPoupUp( this );


		Label lblNome = new Label("Nome:");
		Label lblEnd = new Label("Endereo:");
		Label lblCompl = new Label("Complemento:");
		Label lblCEP = new Label("CEP:");
		Label lblNum = new Label("Nmero:");
		Label lblBairro = new Label("Bairro:");
		Label lblCidade = new Label("Cidade:");
		Label lblUF = new Label("Estado:");
		Label lblCPF = new Label("Tipo Doc.:");
		Label lblEmissao = new Label("Emisso:");
		Label lblOrgaoExp = new Label("Orgo Exp.:");
		Label lblEstado = new Label("Estado:");
		Label lblContato = new Label("Contato:");
		Label lblTelef = new Label("Telefone:");
		Label lblFax = new Label("FAX:");
		Label lblEmail = new Label("E-Mail:");
		Label lblHistorico = new Label("Histrico:");
		Label lblAtivacao = new Label("Ativao:");
		Label lblSexo = new Label("Sexo:");

		Label lblAux = new Label("(DD-MM-YYYY)");
		lblAux.setBackground(param.get_BackColor());
		lblAux.setForeground(param.get_ForeColor());
		lblAux.setFont(param.get_Fonte());

		Label lblAux1 = new Label("(DD-MM-YYYY)");
		lblAux1.setBackground(param.get_BackColor());
		lblAux1.setForeground(param.get_ForeColor());
		lblAux1.setFont(param.get_Fonte());


		choEstado = new Choice();
		choHistorico = new Choice();
		choDoc1 = new Choice();
		choDoc2 = new Choice();

		//********************************
		txtNome = new TextField();
		txtNome.setName("txtNome");
		txtNome.addKeyListener(this);
		txtNome.setBackground(Color.white);
		txtNome.setForeground(Color.black);
		txtNome.setFont(param.get_Fonte());
		//********************************
		txtCompl1 = new TextField();
		txtCompl1.setName("txtCompl1");
		txtCompl1.addKeyListener(this);
		txtCompl1.setBackground(Color.white);
		txtCompl1.setForeground(Color.black);
		txtCompl1.setFont(param.get_Fonte());
		//********************************
		txtLogradouro = new TextField();
		txtLogradouro.setName("txtLogradouro");
		txtLogradouro.addKeyListener(this);
		txtLogradouro.setBackground(Color.white);
		txtLogradouro.setForeground(Color.black);
		txtLogradouro.setFont(param.get_Fonte());
		//********************************
		txtCompl2 = new TextField();
		txtCompl2.setName("txtCompl2");
		txtCompl2.addKeyListener(this);
		txtCompl2.setBackground(Color.white);
		txtCompl2.setForeground(Color.black);
		txtCompl2.setFont(param.get_Fonte());
		//********************************
		txtNum = new TextField();
		txtNum.setName("txtNum");
		txtNum.addKeyListener(this);
		txtNum.setBackground(Color.white);
		txtNum.setForeground(Color.black);
		txtNum.setFont(param.get_Fonte());
		//********************************
		txtCEP = new TextField();
		txtCEP.setName("txtCEP");
		txtCEP.addKeyListener(this);
		txtCEP.setBackground(Color.white);
		txtCEP.setForeground(Color.black);
		txtCEP.setFont(param.get_Fonte());
		//********************************
		txtBairro = new TextField();
		txtBairro.setName("txtBairro");
		txtBairro.addKeyListener(this);
		txtBairro.setBackground(Color.white);
		txtBairro.setForeground(Color.black);
		txtBairro.setFont(param.get_Fonte());
		//********************************
		txtCidade = new TextField();
		txtCidade.setName("txtCidade");
		txtCidade.addKeyListener(this);
		txtCidade.setBackground(Color.white);
		txtCidade.setForeground(Color.black);
		txtCidade.setFont(param.get_Fonte());
		//********************************
		txtDoc1 = new TextField();
		txtDoc1.setName("txtDoc1");
		txtDoc1.addKeyListener(this);
		txtDoc1.setBackground(Color.white);
		txtDoc1.setForeground(Color.black);
		txtDoc1.setFont(param.get_Fonte());
		//********************************
		txtDoc2 = new TextField();
		txtDoc2.setName("txtDoc2");
		txtDoc2.addKeyListener(this);
		txtDoc2.setBackground(Color.white);
		txtDoc2.setForeground(Color.black);
		txtDoc2.setFont(param.get_Fonte());
		//********************************
		txtEmissao = new TextField();
		txtEmissao.setName("txtEmissao");
		txtEmissao.addKeyListener(this);
		txtEmissao.setBackground(Color.white);
		txtEmissao.setForeground(Color.black);
		txtEmissao.setFont(param.get_Fonte());
		//********************************
		txtUF = new TextField();
		txtUF.setName("txtEmissao");
		txtUF.addKeyListener(this);
		txtUF.setBackground(Color.white);
		txtUF.setForeground(Color.black);
		txtUF.setFont(param.get_Fonte());
		//********************************
		txtOrgaoExp = new TextField();
		txtOrgaoExp.setName("txtOrgaoExp");
		txtOrgaoExp.addKeyListener(this);
		txtOrgaoExp.setBackground(Color.white);
		txtOrgaoExp.setForeground(Color.black);
		txtOrgaoExp.setFont(param.get_Fonte());
		//********************************
		txtContato = new TextField();
		txtContato.setName("txtContato");
		txtContato.addKeyListener(this);
		txtContato.setBackground(Color.white);
		txtContato.setForeground(Color.black);
		txtContato.setFont(param.get_Fonte());
		//********************************
		txtTelef = new TextField();
		txtTelef.setName("txtTelef");
		txtTelef.addKeyListener(this);
		txtTelef.setBackground(Color.white);
		txtTelef.setForeground(Color.black);
		txtTelef.setFont(param.get_Fonte());
		//********************************
		txtAtivacao = new TextField();
		txtAtivacao.setName("txtAtivacao");
		txtAtivacao.addKeyListener(this);
		txtAtivacao.setBackground(Color.white);
		txtAtivacao.setForeground(Color.black);
		txtAtivacao.setFont(param.get_Fonte());
		txtAtivacao.setEnabled( false );
		//********************************
		txtEmail = new TextField();
		txtEmail.setName("txtEmail");
		txtEmail.addKeyListener(this);
		txtEmail.setBackground(Color.white);
		txtEmail.setForeground(Color.black);
		txtEmail.setFont(param.get_Fonte());
		//********************************

		choEstado.setBackground(param.get_ForeColor());
		choEstado.setForeground(param.get_WriteColor());
		choEstado.setFont(param.get_Fonte());
		choHistorico.setBackground(param.get_ForeColor());
		choHistorico.setForeground(param.get_WriteColor());
		choHistorico.setFont(param.get_Fonte());
		choDoc1.setBackground(param.get_ForeColor());
		choDoc1.setForeground(param.get_WriteColor());
		choDoc1.setFont(param.get_Fonte());

		choDoc2.setBackground(param.get_ForeColor());
		choDoc2.setForeground(param.get_WriteColor());
		choDoc2.setFont(param.get_Fonte());

		// *** Adiciona valores aos Choices Logradouro e Estado ***
		try
		{
			for ( int i = 0; i < lstLogradouro.getItemCount(); i++ )
				descLogradouro.add( i,lstLogradouro.getItem(i) );

			for ( int i = 0; i < lstEstado.getItemCount(); i++ )
				choEstado.add(lstEstado.getItem(i));

			for ( int i = 0; i < lstHistorico.getItemCount(); i++ )
				choHistorico.add(lstHistorico.getItem(i));

			for ( int i = 0; i < lstEstado.getItemCount(); i++ )
				descUF.add( i,lstEstado.getItem(i) );
		}
		catch( Exception exp ){}

		// **************************************
		rdbMasc = new JRadioButton("Masculino", true);
		rdbMasc.setName( "M" );
		rdbMasc.setBackground( param.get_BackColor() );
		rdbMasc.setForeground( param.get_ForeColor() );
		rdbMasc.setFont( param.get_Fonte() );

		rdbFem = new JRadioButton("Feminino", false);
		rdbFem.setName( "F" );
		rdbFem.setBackground( param.get_BackColor() );
		rdbFem.setForeground( param.get_ForeColor() );
		rdbFem.setFont( param.get_Fonte() );

		ButtonGroup cbg = new ButtonGroup();
		cbg.add( rdbMasc );
		cbg.add( rdbFem );

		//Tratamento do Radio Button
		ClickRadioButton clickradiobutton = new ClickRadioButton();

		rdbFisica = new JRadioButton( "Fisica", true);
		rdbFisica.setName( "F" );
		rdbFisica.setActionCommand( "F" );
		rdbFisica.addItemListener( clickradiobutton );
		rdbFisica.setBackground( param.get_BackColor() );
		rdbFisica.setForeground( param.get_ForeColor() );
		rdbFisica.setFont( param.get_Fonte() );

		rdbJuridica = new JRadioButton("Juridica", false);
		rdbJuridica.setName( "J" );
		rdbJuridica.setActionCommand( "J" );
		rdbJuridica.addItemListener( clickradiobutton );
		rdbJuridica.setBackground( param.get_BackColor() );
		rdbJuridica.setForeground( param.get_ForeColor() );
		rdbJuridica.setFont( param.get_Fonte() );

		cbg2 = new ButtonGroup();
		cbg2.add( rdbFisica );
		cbg2.add( rdbJuridica );

		bttCEP = new Button( "Pesquisar" );
		bttCEP.setForeground( Color.black );
		bttCEP.setFont( param.get_Fonte() );
		bttCEP.addActionListener(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					if( txtCEP.getText().length() > 0 )
					{
						if( clsCheckString.isNumeric( txtCEP.getText().toString() ) == false )
						{
							JOptionPane.showMessageDialog( clsCadastro,
								"CEP deve conter apenas numeros",
								"Ateno",JOptionPane.WARNING_MESSAGE );

						}
						else
						{
							clsCadastro.setMensag( "Pesquisando..." );
							consultaCEP( txtCEP.getText() );
							clsCadastro.setMensag( "" );
						}
					}
					else
						JOptionPane.showMessageDialog( clsCadastro,
							"Campo CEP nulo","Ateno",JOptionPane.WARNING_MESSAGE );
				}
			} );

		bttEndereco = new Button( "Pesquisar" );
		bttEndereco.setForeground( Color.black );
		bttEndereco.setFont( param.get_Fonte() );
		bttEndereco.addActionListener(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					myPoupUp.setShow();
				}
			} );


		txtLogradouro.setEnabled(false);
		txtCompl1.setEnabled(false);
		txtCidade.setEnabled(false);
		txtUF.setEnabled(false);
		txtEmissao.setEnabled( true );
		txtOrgaoExp.setEnabled( true );

		setDocumento( "F" );

		// ********************************************************

		GridBagConstraints gbcConstraints = new GridBagConstraints();
		GridBagLayout gblClienteInformacao = new GridBagLayout();
		AddGridComponente grdAddClienteInformacao = new AddGridComponente(gblClienteInformacao,gbcConstraints,14,20);

		grdAddClienteInformacao.addComponente(lblNome,gblClienteInformacao,gbcConstraints,1,1,1,1);
		grdAddClienteInformacao.addComponente(lblEnd,gblClienteInformacao,gbcConstraints,2,1,1,1);
		grdAddClienteInformacao.addComponente(lblCompl,gblClienteInformacao,gbcConstraints,3,1,1,1);
		grdAddClienteInformacao.addComponente(lblBairro,gblClienteInformacao,gbcConstraints,4,1,1,1);
		grdAddClienteInformacao.addComponente(lblUF,gblClienteInformacao,gbcConstraints,5,1,1,1);
		grdAddClienteInformacao.addComponente(new Label( "Pessoa:" ),gblClienteInformacao,gbcConstraints,6,1,1,1);
		grdAddClienteInformacao.addComponente(lblCPF,gblClienteInformacao,gbcConstraints,8,1,1,1);
		grdAddClienteInformacao.addComponente(lblOrgaoExp,gblClienteInformacao,gbcConstraints,10,1,1,1);
		grdAddClienteInformacao.addComponente(lblContato,gblClienteInformacao,gbcConstraints,11,1,1,1);
		grdAddClienteInformacao.addComponente(lblHistorico,gblClienteInformacao,gbcConstraints,12,1,1,1);
		grdAddClienteInformacao.addComponente(lblSexo,gblClienteInformacao,gbcConstraints,13,1,1,1);

		// ******* Nome ********
		grdAddClienteInformacao.addComponente(txtNome,gblClienteInformacao,gbcConstraints,1,2,1,28);

		// *********** Endereo **********
		grdAddClienteInformacao.addComponente(txtLogradouro,gblClienteInformacao,gbcConstraints,2,2,1,5);
		grdAddClienteInformacao.addComponente(txtCompl1,gblClienteInformacao,gbcConstraints,2,8,1,14);
		grdAddClienteInformacao.addComponente(bttEndereco,gblClienteInformacao,gbcConstraints,2,23,1,7);

		// ********* Complemento *********
		grdAddClienteInformacao.addComponente(txtCompl2,gblClienteInformacao,gbcConstraints,3,2,1,15);
		grdAddClienteInformacao.addComponente(lblNum,gblClienteInformacao,gbcConstraints,3,18,1,3);
		grdAddClienteInformacao.addComponente(txtNum,gblClienteInformacao,gbcConstraints,3,23,1,7);

		// ******* Bairro ********
		grdAddClienteInformacao.addComponente(txtBairro,gblClienteInformacao,gbcConstraints,4,2,1,10);
		grdAddClienteInformacao.addComponente(lblCidade,gblClienteInformacao,gbcConstraints,4,13,1,3);
		grdAddClienteInformacao.addComponente(txtCidade,gblClienteInformacao,gbcConstraints,4,17,1,13);

		// ********** UF **********
		grdAddClienteInformacao.addComponente(txtUF,gblClienteInformacao,gbcConstraints,5,2,1,10);

		// ******* CEP ********
		grdAddClienteInformacao.addComponente(lblCEP,gblClienteInformacao,gbcConstraints,5,13,1,3);
		grdAddClienteInformacao.addComponente(txtCEP,gblClienteInformacao,gbcConstraints,5,17,1,4);
		grdAddClienteInformacao.addComponente(bttCEP,gblClienteInformacao,gbcConstraints,5,23,1,7);

		// ******* Tipo de Pessoa ********
		grdAddClienteInformacao.addComponente(rdbFisica,gblClienteInformacao,gbcConstraints,6,2,1,5);
		grdAddClienteInformacao.addComponente(rdbJuridica,gblClienteInformacao,gbcConstraints,6,8,1,5);

		// ******* CPF ********
		grdAddClienteInformacao.addComponente(choDoc1,gblClienteInformacao,gbcConstraints,7,2,1,10);
		grdAddClienteInformacao.addComponente(txtDoc1,gblClienteInformacao,gbcConstraints,7,17,1,13);
		grdAddClienteInformacao.addComponente(new Label ("Docto:"),gblClienteInformacao,gbcConstraints,7,13,1,3);

		grdAddClienteInformacao.addComponente(choDoc2,gblClienteInformacao,gbcConstraints,8,2,1,10);
		grdAddClienteInformacao.addComponente(txtDoc2,gblClienteInformacao,gbcConstraints,8,17,1,13);

		// ******* RG ********
		grdAddClienteInformacao.addComponente(lblEmissao,gblClienteInformacao,gbcConstraints,9,1,1,1);
		grdAddClienteInformacao.addComponente(txtEmissao,gblClienteInformacao,gbcConstraints,9,2,1,4);
		grdAddClienteInformacao.addComponente(lblAux,gblClienteInformacao,gbcConstraints,9,6,1,5);

		//******** Orgo Expedidor *****
		grdAddClienteInformacao.addComponente(txtOrgaoExp,gblClienteInformacao,gbcConstraints,10,2,1,3);
		grdAddClienteInformacao.addComponente(lblEstado,gblClienteInformacao,gbcConstraints,10,13,1,3);
		grdAddClienteInformacao.addComponente(choEstado,gblClienteInformacao,gbcConstraints,10,17,1,13);


		// ******* Telefone ********
		grdAddClienteInformacao.addComponente(txtContato,gblClienteInformacao,gbcConstraints,11,2,1,10);
		grdAddClienteInformacao.addComponente(lblTelef,gblClienteInformacao,gbcConstraints,11,13,1,3);
		grdAddClienteInformacao.addComponente(txtTelef,gblClienteInformacao,gbcConstraints,11,17,1,5);


		// ********** Histrico *****
		grdAddClienteInformacao.addComponente(choHistorico,gblClienteInformacao,gbcConstraints,12,2,1,10);
		grdAddClienteInformacao.addComponente(lblAtivacao,gblClienteInformacao,gbcConstraints,12,13,1,3);
		grdAddClienteInformacao.addComponente(txtAtivacao,gblClienteInformacao,gbcConstraints,12,17,1,5);
		grdAddClienteInformacao.addComponente(lblAux1,gblClienteInformacao,gbcConstraints,12,22,1,11);


		// ******* Sexo ********
		grdAddClienteInformacao.addComponente(rdbMasc,gblClienteInformacao,gbcConstraints,13,2,1,5);
		grdAddClienteInformacao.addComponente(rdbFem,gblClienteInformacao,gbcConstraints,13,8,1,5);

		// ******** Email ******
		grdAddClienteInformacao.addComponente(lblEmail,gblClienteInformacao,gbcConstraints,13,13,1,3);
		grdAddClienteInformacao.addComponente(txtEmail,gblClienteInformacao,gbcConstraints,13,17,1,13);

		setLayout(new GridLayout(1,1));
		add(grdAddClienteInformacao);

		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());

		txtNome.requestFocus();
	}

	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e)	{}

	/*****************************************************************************
	Verifica quem originou o evento e define se o boto deve ou no ser habilitado
	******************************************************************************/
	public void itemStateChanged(ItemEvent e){}

	public void reset()
	{
		setNome("");
		setLogradouro("");
		setCompl1("");
		setCompl2("");
		setNum("");
		setBairro("");
		setCidade("");
		setUF("");
		setCEP("");
		setDoc1("");
		setDoc2("");
		setEmissao("");
		setOrgaoExp("");
		setEstado("");
		setContato("");
		setTelef("");
		setEmail("");
		setAtivacao("");
		setHistorico("");
		setSexo("");
	}

	public void setFocusAll( TextField pTxt )
	{
		pTxt.selectAll();
		pTxt.requestFocus();
	}

	public String getNome()
	{
		return txtNome.getText().toUpperCase();
	}

	public String getLogradouro()
	{
		for( int widx = 0; widx < descLogradouro.size(); widx++ )
		{
			if( txtLogradouro.getText().equals( descLogradouro.get( widx ) ) )
				return codLogradouro[ widx ];
		}
		return codLogradouro[ 0 ];
	}

	public String getCompl1()
	{
		return txtCompl1.getText();
	}

	public String getCompl2()
	{
		return txtCompl2.getText().toUpperCase();
	}

	public String getNum()
	{
		return txtNum.getText().toString().toUpperCase();
	}

	public String getBairro()
	{
		return txtBairro.getText().toUpperCase();
	}

	public String getCidade()
	{
		return txtCidade.getText();
	}

	public String getUF()
	{
		for( int widx = 0; widx < descUF.size(); widx++ )
		{
			if( txtUF.getText().equals( descUF.get( widx ) ) )
				return codUF[ widx ];
		}
		return codUF[ 0 ];
	}

	public String getCEP()
	{
		return txtCEP.getText();
	}

	public String getTipoDoc1()
	{
		if( !param.getSubstring( "-",choDoc1.getSelectedItem(),0 ).equals( "RG" ) )
		{
			setEmissao( "" );
			setOrgaoExp( "" );
		}

		return param.getSubstring( "-",choDoc1.getSelectedItem(),0 );
	}

	public String getTipoDoc2()
	{
		return param.getSubstring( "-",choDoc2.getSelectedItem(),0 );
	}

	public String getDoc1()
	{
		return txtDoc1.getText();
	}

	public String getDoc2()
	{
		return txtDoc2.getText();
	}

	public String getFormatEmissao()
	{
		String emissao="30-02-2002";
		if( txtEmissao.getText().trim().length() == 10 )
		{
			emissao = txtEmissao.getText();
		}
		if( txtEmissao.getText().trim().length() <= 0 )
			emissao="";

		return emissao;
	}
	public String getEmissao()
	{
		String emissao="";
		if( txtEmissao.getText().trim().length() == 10 )
		{
			emissao = txtEmissao.getText().substring(6, txtEmissao.getText().length()) +
					  txtEmissao.getText().substring(3,5) +
					  txtEmissao.getText().substring(0,2);
		}
		return emissao;
	}

	public String getOrgaoExp()
	{
		return txtOrgaoExp.getText().toUpperCase();
	}

	public String getEstado()
	{
		return codEstado[ choEstado.getSelectedIndex() ];
	}

	public String getContato()
	{
		return txtContato.getText().toUpperCase();
	}

	public String getTelef()
	{
		return txtTelef.getText();
	}

	public String getEmail()
	{
		return txtEmail.getText().toLowerCase();
	}

	public String getFormatAtivacao()
	{
		String ativacao="30-02-2002";
		if( txtAtivacao.getText().trim().length() == 10 )
		{
			ativacao = txtAtivacao.getText();
		}
		return ativacao;
	}
	public String getAtivacao()
	{
		String ativacao="30-02-2002";
		if( txtAtivacao.getText().trim().length() == 10 )
		{
			ativacao = txtAtivacao.getText().substring(6, txtAtivacao.getText().length()) +
					   txtAtivacao.getText().substring(3,5) +
					   txtAtivacao.getText().substring(0,2);
		}
		return ativacao;
	}

	public String getHistorico()
	{
		return codHistorico[ choHistorico.getSelectedIndex() ];
	}

	public String getSexo()
	{
		if ( rdbMasc.isSelected() == true )
			return "M";
		else
			return "F";
	}

	public String getPessoa()
	{
		if ( rdbFisica.isSelected() == true )
			return "F";
		else
			return "J";
	}

	public void setNome(String nome)
	{
		txtNome.setText(nome.toUpperCase());
	}

	public void setLogradouro(String logradouro)
	{
		int i=0;
		if( logradouro.length() > 0 )
		{
			for ( i = 0; i < descLogradouro.size(); i++)
			{
				if ( codLogradouro[i].equals(logradouro) ) break;
			}
		}
		txtLogradouro.setText( descLogradouro.get( i ).toString() );
	}

	public void setCompl1(String compl1)
	{
		txtCompl1.setText(compl1.toUpperCase());
	}

	public void setCompl2(String compl2)
	{
		txtCompl2.setText(compl2.toUpperCase());
	}

	public void setNum(String num)
	{
		txtNum.setText(num.toUpperCase());
	}

	public void setBairro(String bairro)
	{
		txtBairro.setText(bairro.toUpperCase());
	}

	public void setCidade(String cidade)
	{
		txtCidade.setText(cidade);
	}

	public void setUF(String uf)
	{
		int i=0;
		if( uf.length() > 0 )
		{
			for ( i = 0; i < descLogradouro.size(); i++)
			{
				if ( codUF[i].equals(uf) ) break;
			}
		}
		txtUF.setText( descUF.get( i ).toString() );
	}

	public void setCEP(String cep)
	{
		txtCEP.setText(cep);
	}

	public void setPessoa( String pStr )
	{
		rdbFisica.setSelected( true );
		if( pStr.length() > 0 )
		{
			if ( pStr.equals( "F" ) )
				rdbFisica.setSelected( true );
			else
				rdbJuridica.setSelected( true );
		}
	}

	public void setTipoDoc1(String estado)
	{
		int i=0;
		choDoc1.select(0);

		if( getPessoa().equals( "J" ) ) return;

		if( estado.length() > 0 )
		{
			for ( int wi = 0;; wi++)
			{
				if ( codDoc1[wi].equals(estado) )
				{
					choDoc1.select(i);
					break;
				}

				if( getPessoa().equals( "F" ) && !codDoc1[wi].equals("IE") )
					i++;
			}
		}
	}

	public void setTipoDoc2(String estado)
	{
		int i=0;
		choDoc2.select(0);

		if( getPessoa().equals( "J" ) ) return;

		if( estado.length() > 0 )
		{
			for ( int wi = 0;; wi++)
			{
				if ( codDoc2[wi].equals(estado) )
				{
					choDoc2.select(i);
					break;
				}
				if( getPessoa().equals( "F" ) && !codDoc2[wi].equals("CNPJ") )
					i++;

			}
		}
	}

	public void setDoc1(String estado)
	{
		txtDoc1.setText( estado );
	}

	public void setDoc2(String estado)
	{
		txtDoc2.setText( estado );
	}

	public void setEmissao(String emissao)
	{
		if ( emissao.length() > 0 )
			emissao = 	emissao.substring(6,emissao.length()) + "-" +
					 	emissao.substring(4,6) + "-" +
					 	emissao.substring(0,4);
		txtEmissao.setText(emissao);
	}

	public void setOrgaoExp(String orgao)
	{
		txtOrgaoExp.setText(orgao);
	}

	public void setEstado(String estado)
	{
		int i=0;
		if( estado.length() > 0 )
		{
			for ( i = 0;; i++)
			{
				if ( codEstado[i].equals(estado) ) break;
			}
		}
		choEstado.select(i);
	}

	public void setContato(String contato)
	{
		txtContato.setText(contato.toUpperCase());
	}

	public void setTelef(String telefone)
	{
		txtTelef.setText(telefone);
	}

	public void setEmail(String email)
	{
		txtEmail.setText(email.toLowerCase());
	}

	public void setAtivacao(String ativacao)
	{
		if ( ativacao.length() > 0 )
			ativacao = 	ativacao.substring(6,ativacao.length()) + "-" +
					 	ativacao.substring(4,6) + "-" +
					 	ativacao.substring(0,4);
		txtAtivacao.setText(ativacao);
	}

	public void setHistorico(String hist)
	{
		int i=0;

		if( hist.length() > 0 && !hist.equals( "0" ) )
		{
			for ( i = 0;; i++)
			{
				if ( codHistorico[i].equals( hist.toString() ) ) break;
			}
		}
		choHistorico.select(i);
	}

	public void setSexo(String sexo)
	{
		if ( sexo.length() != 0 )
			if ( sexo.equals("F") )
				rdbFem.setSelected(true);
			else
				rdbMasc.setSelected(true);

	}

	//Trata as aes do Radio Button
	public class ClickRadioButton implements ItemListener
	{
		public void itemStateChanged( ItemEvent e )
		{
			String wtipo = cbg2.getSelection().getActionCommand();

			if( wtipo.equals( "F" ) )
			{
				txtEmissao.setEnabled( true );
				txtOrgaoExp.setEnabled( true );
				setDoc1( "" );
				setDoc2( "" );
				choEstado.setEnabled( true );
				choEstado.select( 0 );

				setDocumento( "F" );

			}
			else
			{
				txtEmissao.setEnabled( false );
				txtOrgaoExp.setEnabled( false );
				setDoc1( "" );
				setDoc2( "" );
				setEmissao( "" );
				setOrgaoExp( "" );
				choEstado.setEnabled( false );
				choEstado.select( 0 );

				setDocumento( "J" );

			}
		}
	}
	public void setDocumento( String pStr )
	{
		choDoc1.removeAll();
		choDoc2.removeAll();

		try
		{

			if( pStr.equals( "F" ) )
			{
				for ( int i = 0; i < lstDoc1.getItemCount(); i++ )
				{
					if( !codDoc1[ i ].equals( "IE" ) )
					{
						choDoc1.add(lstDoc1.getItem(i));
					}
				}
				for ( int i = 0; i < lstDoc2.getItemCount(); i++ )
				{
					if( !codDoc2[ i ].equals( "CNPJ" ) )
					{
						choDoc2.add(lstDoc2.getItem(i));
					}
				}
			}
			else
			{
				for ( int i = 0; i < lstDoc1.getItemCount(); i++ )
				{
					if( codDoc1[ i ].equals( "IE" ) )
					{
						choDoc1.add(lstDoc1.getItem(i));
					}

				}
				for ( int i = 0; i < lstDoc2.getItemCount(); i++ )
				{
					if( codDoc2[ i ].equals( "CNPJ" ) )
					{
						choDoc2.add(lstDoc2.getItem(i));
					}
				}
			}
		}
		catch( Exception exp ){}
	}
	/************************************************
	Consulta celular e carrega as informaes na tela
	*************************************************/
	private void consultaCEP(String pCEP)
	{
		String result;
		String contexto = "?param=<TRANSACAO>5</TRANSACAO><CEP>" + pCEP.toString() + "</CEP>"
					+ param.getCtrl();
		final int etx=0x03;

		try
		{
			URL urlClienteInformacao = new URL(param.get_Middleware()+contexto);
			URLConnection connection = urlClienteInformacao.openConnection();
			DataInputStream in = new DataInputStream(connection.getInputStream());
			StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};
			in.close();
			String status = param.xml_get(arq.toString(),"ERR_MENS");
			int erro = Integer.parseInt(param.xml_get(arq.toString(),"ERR"));
			if(status != null)
			{
				if ( status.equals("OK") )
					mostraCEP(arq.toString());
				else
				{
					JOptionPane.showMessageDialog(null, "CEP no localizado !", "Aviso", JOptionPane.ERROR_MESSAGE);
				}
			}
			else
			{
				JOptionPane.showMessageDialog(null, "Sem resposta", "Erro", JOptionPane.ERROR_MESSAGE);
			}
		}
		catch(MalformedURLException mue)
		{
			System.out.println("Illegal URL: " + mue);
		}
		catch(IOException ioe)
		{
			System.out.println("IOException: " + ioe);
		}
		catch(Exception e)
		{
			System.out.println("Error: " + e);
		}
	}

	public void setLinha( String xCep )
	{
		txtCEP.setText( xCep );
	}

	/*******************************
	Mostra as informaes nos campos
	********************************/
	private void mostraCEP( String buffer )
	{
		setLogradouro(param.xml_get(buffer,"LOGR"));
		setCompl1(param.xml_get(buffer,"END"));
		setCidade(param.xml_get(buffer,"CID"));
		setUF(param.xml_get(buffer,"UF"));

		repaint();
	}

	public class MyPoupUp extends PoupUp
	{
		private ClienteInformacao clsClienteInformacao;

		public MyPoupUp( ClienteInformacao xClienteInformacao )
		{
			super();

			clsClienteInformacao = xClienteInformacao;

			setColumnAddElement( "CEP" );
			setColumnAddElement( "                  Endereo                  " );
			setColumnAddElement( "   Localidade   " );
			montaPoupUp();

			setTitulo( "Busca de Endereco" );
			setTexto( "Digite o endereo SEM o logradouro( Rua, Av., etc )" );
			setTransacao( 102 );
			setTagSet( "END" );
			setTagGet( "LCEP" );

		}

		public void setShow()
		{
			super.setShow();
		}

		public String getLinha()
		{
			String wcep = super.getLinha();

			if( wcep.length() > 0 )
			{
				clsClienteInformacao.consultaCEP( wcep );
				clsClienteInformacao.txtCEP.setText( wcep );
			}
			else
			{
				JOptionPane.showMessageDialog( this,"Informao no indicada",
						"Ateno",JOptionPane.WARNING_MESSAGE );
			}
			return wcep;
		}
	}
}