import java.awt.*;
import java.applet.Applet;

class Titulo extends Panel
{
	String mensag;
	Dimension size;
	Font lbl_font = new Font("verdana", Font.BOLD, 12);
	int width, height;

	public Titulo(String msg, int initialWidth, int initialHeight)
	{
		width=initialWidth;
		height=initialHeight;
		size = new Dimension(width,height);
		mensag = msg;
	}

	public Dimension getPreferredSize()
	{
		return getMinimumSize();
	}

	public Dimension getMinimumSize()
	{
		return size;
	}

	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		Dimension d = getSize();
		width = (int) d.width;
		height = (int) d.height;

		g.setColor(Color.lightGray);
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.black);
		g.setFont(lbl_font);
		g.drawString(mensag,3,12);
	}

	public void setMensag(String msg)
	{
		mensag = msg;
		repaint();
	}

	public String getMensag()
	{
		return mensag;
	}

}