import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class HTTPEspiaT extends HttpServlet
{
	private Parametro param = new Parametro();

	public void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException
	{
		PrintWriter output;

		response.setContentType( "text/html" );		// content type
		output = response.getWriter();				// get writer

		// create and send HTML page to client
		StringBuffer buf = new StringBuffer();

		try
		{
			String aux = getEspia();
			//System.out.println(aux);
			buf.append( aux );
		}
		catch (Exception e)
		{
			log(e.toString());
			buf.append( param.get_HTML_Interromper("ERRO", e.toString()) );
		}

		buf.append( param.get_HTML_Fim() );

      	output.println( buf.toString() );
		output.close();							// close PrintWriter stream
	}

	// Obtem resultados
	private String getEspia() throws Exception
	{
		String aux;
		StringBuffer buf;

		ClientSock clisock = new ClientSock();

		try
		{
			String resp = clisock.runClient();
			clisock = null;
			String status = param.xml_get(resp, "STT");

			if ( !(status.equals("OK")) )
			{
				String mens_erro = "Falhou comunicao com servidor";
				throw new Exception( mens_erro );
			}

			buf = new StringBuffer();
			buf.append( param.get_HTML_Inicio( param.get_Titulo()) );
			buf.append( param.get_codeEspia() );
			buf.append( param.criaParam("panel", 0, "1"));
			buf.append( param.criaParam("dados", 0, resp));

			return buf.toString();
		}
		catch (Exception e)
		{
			throw e;
		}
	}
}
