import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.awt.Label;
import java.awt.TextField;
import java.applet.Applet;
import java.applet.AppletContext;

public class Login extends Applet
{
	private Button btOk, btSair;
	private Dimension size;
	private URL newDocument;
	private String contexto;
	private static final Parametro param = new Parametro();

	public void init()
	{
		size = getSize();

		System.out.println("ERRO.....");

		btOk = new Button();
		btOk.setLabel("Ok");
		btOk.setEnabled(false);
		btOk.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					validaLogin();
				}
			});

		btSair = new Button();
		btSair.setLabel("Telesp");
		btSair.setEnabled(true);
		btSair.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					paginaTelesp();
				}
			});

		Titulo titulo = new Titulo(param.TITULO,20,20);
		Usuario usr = new Usuario();

		Panel panelSup = new Panel(new BorderLayout(5,5));
		panelSup.add(titulo, BorderLayout.NORTH);
		panelSup.add(usr, BorderLayout.CENTER);

		Panel panel2 = new Panel(new GridLayout(1,2,5,5));
		panel2.add(btOk);
		panel2.add(btSair);
		Panel panelInf = new Panel(new FlowLayout(FlowLayout.CENTER));
		panelInf.add(panel2);

		setLayout(new BorderLayout(5,5));
		add (panelSup, BorderLayout.NORTH);
		add (panelInf, BorderLayout.SOUTH);

		setBackground(param.BG1);
		setForeground(param.FG1);
		setSize(size);
	}

	// Valida o usuario
	private void validaLogin()
	{
		// Cria a URL
		try
		{
			System.out.println(param.get_ValidaLogin()+contexto+param.getCtrl());

			newDocument = new URL(param.get_ValidaLogin()+contexto);
			AppletContext browser = getAppletContext();
			browser.showDocument ( newDocument, param.TARGET_WINDOW );
		}
		catch (Exception e)
		{
			System.out.println("URL Invalido");
		}
		newDocument = null;
	}

	// Pgina Telesp
	private void paginaTelesp()
	{
		// Cria a URL
		try
		{
			newDocument = new URL(param.get_homeTelesp());
			AppletContext browser = getAppletContext();
			browser.showDocument ( newDocument, param.TARGET_WINDOW );
		}
		catch (Exception e)
		{
			System.out.println("URL Invalido");
		}
		newDocument = null;
	}

	//
	private class Usuario extends Panel implements KeyListener
	{
		private TextField txtUsr;
		private TextField txtSen;
		private Dimension sizeP;

		public Usuario()
		{
			int mHeight, mWidth;

			mHeight = (int)(size.height * 0.5);
			mWidth = (int)(size.width);

			sizeP = new Dimension(mWidth, mHeight);
			Label lblUsr = new Label("Usurio");
			Label lblSen = new Label("Senha");
			txtUsr = new TextField(12);
			txtUsr.addKeyListener(this);

			txtSen = new TextField(12);
			txtSen.setEchoChar('*');
			txtSen.addKeyListener(this);

			setLayout(new GridLayout(2,2,5,5));
			add(lblUsr);
			add(txtUsr);
			add(lblSen);
			add(txtSen);
			setSize(sizeP);
		}

		public Dimension getPreferredSize()
		{
			return getMinimumSize();
		}

		public Dimension getMinimumSize()
		{
			return sizeP;
		}

		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			g.setColor(Color.blue);
			g.drawRoundRect(1, 1, sizeP.width - 3, sizeP.height - 3, 10, 10);
		}

		public Insets getInsets()
		{
			return new Insets(5,5,5,5);
		}

		public void keyPressed(KeyEvent e) {}
		public void keyReleased(KeyEvent e)	{}
		public void keyTyped(KeyEvent e)
		{
			habConfirma();
		}

		private void habConfirma()
		{
			try
			{
				if ((txtUsr.getText().length() > 0) && (txtSen.getText().length() > 0))
				{
					contexto = "?usuario=" + txtUsr.getText().trim() +
							  "&senha=" + txtSen.getText().trim();
					btOk.setEnabled(true);
				}
				else
					btOk.setEnabled(false);
			}
			catch (Exception e) {};
		}
	}
}
