// Parametros para os Indicadores

import java.awt.Color;
import java.awt.Font;

public class Parametro
{
	public static final String TITULO="INDICADORES PPS - Vr 1.1";
	//public static final String HOME_HTTP="http://10.21.30.111:8080/indicadores/servlet/";
	public static final String HOME_HTTP="http://localhost:8080/indicadores/servlet/";
	public static final String APPLET="/indicadores/applets/";
	public static final String VALIDA_LOGIN="HTTPGetValidaLogin";
	public static final String INDICADORES="HTTPGetSaldoTipo";
	public static final String homeLogin="HTTPGetHomeLogin";
	public static final String RESULTADO="HTTPGetResultado";
	public static final String homeAviso="HTTPGetHomeAviso";
	public static final String homeDados="HTTPPostHome";
	public static final String homeTelesp="http://www.telespcelular.com.br";
	public static final Character aspasDuplas = new Character('"');

	public static final String CODE_INDICADORES=" code=Indicadores.class width=300 height=200>\n";
	public static final String codeAviso=" code=Aviso.class width=400 height=150>\n";
	public static final String CODE_RESULTADO=" code=Resultado.class width=600 height=250>\n";
	public static final String codeLogin=" code=Login.class width=200 height=130>\n";

	public static final String FUNDO="/indicadores/images/h_fundo2.jpg";
	public static final int remotePort=5001;
	//public static final String remoteHost="10.254.1.131";
	public static final String remoteHost="200.212.96.28";
	public static final String TARGET_WINDOW="_self";
	public static int seq=0;

	//public static final String logFile="/teste/jakarta-tomcat-3.2.1/webapps/indicadores/debug/indicadores";
	public static final String logFile="indicadores";

	public static final String LOGO2 = "/indicadores/images/javalogo.gif";
	public static final Color BG1 = Color.lightGray;
	public static final Color FG1 = Color.black;
	public static final Color BG2 = Color.orange;
	public static final Font FONTE1 = new Font("Ariel", Font.BOLD, 14);
	public static final Font FONTE2 = new Font("Arial", Font.PLAIN, 12);
	public static final Font FONTE3 = new Font("Arial", Font.BOLD + Font.PLAIN, 12);

	public static final char US = '';
	public static final String DECIMAL_FORMAT="###,###,###,##0.00";

	public static String get_Logo2()
	{
		return LOGO2;
	}

	public static String get_logFile()
	{
		return logFile;
	}

	public static String get_Titulo()
	{
		return TITULO;
	}

	public static String get_APPLET()
	{
		return (aspasDuplas + APPLET + aspasDuplas);
	}

	public static String get_ValidaLogin()
	{
		return HOME_HTTP + VALIDA_LOGIN;
	}

	public static String get_homeIndicadores()
	{
		return HOME_HTTP + INDICADORES;
	}

	public static String get_homeLogin()
	{
		return HOME_HTTP + homeLogin;
	}

	public static String get_Resultado()
	{
		return HOME_HTTP + RESULTADO;
	}

	public static String get_homeAviso()
	{
		return HOME_HTTP + homeAviso;
	}

	public static String get_homeDados()
	{
		return HOME_HTTP + homeDados;
	}

	public static String get_homeTelesp()
	{
		return homeTelesp;
	}

	public static String get_codeIndicadores()
	{
		return CODE_INDICADORES;
	}

	public static String get_codeAviso()
	{
		return codeAviso;
	}

	public static String get_codeResultado()
	{
		return CODE_RESULTADO;
	}

	public static String get_codeLogin()
	{
		return codeLogin;
	}

	// Cria parametros
	public String criaParam(String tit, int index, String val)
	{
		if (index == 0)
			return ("<param name=" + tit.trim() + retValue( val ));
		else
			return ("<param name=" + tit.trim() + index + retValue( val ));
	}

	private String retValue(String val)
	{
		String tmp = val.trim();
		//if (tmp.length() == 0) tmp = ".";

		return (" value=" + aspasDuplas + tmp + aspasDuplas + ">\n");
	}

	public static Character get_aspasDuplas()
	{
		return aspasDuplas;
	}

	public static String get_Fundo()
	{
		return get_aspasDuplas() + FUNDO + get_aspasDuplas();
	}

	public static int get_remotePort()
	{
		return remotePort;
	}

	public static String get_remoteHost()
	{
		return remoteHost;
	}

	// Texto inicial do html
	public String get_HTML_Inicio()
	{
		return get_HTML_Inicio(get_Titulo() );
	}

	public String get_HTML_Inicio(String titulo)
	{
		StringBuffer buf = new StringBuffer();
		buf.append("<html>\n");
		buf.append("<head><title>" + titulo + "</title></head>\n" );
		buf.append("<body background=" + get_Fundo() + ">\n");
		buf.append("<center>\n");
		buf.append("<font color=\"gold\" size=\"3\" face=\"Arial\">\n");
		buf.append("<h1>" + titulo + "</h1>\n");
		buf.append("</font>\n");
		buf.append("</center>\n");
		//buf.append("<hr>\n");
		buf.append("<p align=\"center\">\n");
		buf.append("<applet codebase=" + get_APPLET());
		return buf.toString();
	}

	public String get_HTML_Inicio(String titulo, String sessao)
	{
		StringBuffer buf = new StringBuffer();
		buf.append("<html>\n");
		buf.append("<head><title>" + titulo + "</title></head>\n" );
		buf.append("<body background=" + get_Fundo() + ">\n");
		buf.append("<center>\n");
		buf.append("<font color=\"gold\" size=\"3\" face=\"Arial\">\n");
		buf.append("<h1>" + titulo + "</h1>\n");
		buf.append( sessao );
		buf.append("</font>\n");
		buf.append("</center>\n");
		//buf.append("<hr>\n");
		buf.append("<p align=\"center\">\n");
		buf.append("<applet codebase=" + get_APPLET());
		return buf.toString();
	}

	// Texto final do html
	public String get_HTML_Fim()
	{
		StringBuffer buf = new StringBuffer();
		buf.append( "alt=" + get_aspasDuplas() + "Seu 'browser' no entende o &lt;APPLET&gt;");
		buf.append( "tag porm o applet no est rodando o applet por alguma razo." + get_aspasDuplas());
		buf.append( "Seu 'browser' esta ignorando completamente o &lt;APPLET&gt; tag!");
		buf.append( "</applet>");
		//buf.append( "<hr>\n");
		buf.append( "</body>\n");
		buf.append( "</html>\n");
		return buf.toString();
	}

	// HTML para interromper processo
	public String get_HTML_Interromper(String titulo, String mensagem)
	{
		return makeHTML(titulo, mensagem, get_homeLogin());
	}

	// HTML para interromper processo
	public String get_HTML_Resultado(String titulo, String mensagem, String username)
	{
		return makeHTML(titulo, mensagem, get_Resultado()) + criaParam("username", 0, username);
	}

	// HTML para interromper processo
	private String makeHTML(String titulo, String mensagem, String url)
	{
		StringBuffer aux = new StringBuffer();
		aux.append( get_HTML_Inicio(titulo));
		aux.append( get_codeAviso() );
		aux.append( criaParam("titulo", 0, titulo));
		aux.append( criaParam("mensagem", 0, mensagem));
		aux.append( criaParam("url", 0, url));
		return aux.toString();
	}

	// Inicia string no formato XML
	public String xml_ini()
	{
		return ("<?xml version='1.0' encoding='ISO-8859-1'?>\n");
	}

	// Fabrica string no formato XML
	public String xml_str(String tag, String val)
	{
		String aux =	"<" + tag.toString().trim() + ">" + val.toString().trim() +
						"</" + tag.toString().trim() + ">\n";
		return aux;
	}

	// Fabrica string no formato XML
	public String xml_str(String tag, int val)
	{
		Integer num = new Integer(val);

		String aux =	"<" + tag.toString().trim() + ">" + num.toString() +
						"</" + tag.toString().trim() + ">\n";
		return aux;
	}

	// Fabrica string da transao no formato XML
	public String xml_transac(int val)
	{
		Integer num = new Integer(val);
		return (xml_str("TRANSAC", num.toString()));
	}

	// Devolve string formatado em XML
	public String xml_get(String buffer, String tag)
	{
		String tag1 = "<" + tag.toString().trim() + ">";
		String tag2 = "</" + tag.toString().trim() + ">";
		String resp;
		int pos1, pos2;

		resp = "";
		pos1 = buffer.indexOf(tag1);
		pos2 = buffer.indexOf(tag2);

		if(pos1 != -1)
		{
			pos1 = pos1 + tag1.length();
			if (pos2 != -1)
			{
				if(pos1 < pos2)
				{
					resp = buffer.substring(pos1,pos2);
				}
			}
		}

		return resp;
	}

	// Devolve string com o cdigo de erro
	public String getCodigoErro(String msg)
	{
		int i = msg.indexOf(",");
		if (i > 0)
			msg = msg.substring(0, i);
		else
			msg = "Erro";
		return msg;
	}

	// Devolve descricao do erro
	public String getDescricaoErro(String msg)
	{
		int i = msg.indexOf(",");
		if (i > 0) msg = msg.substring(++i).trim();
		return msg;
	}

	// Devolve controle sequencial
	public static String getCtrl()
	{
		String aux = " &ctrl=" + (++seq);
		System.out.println(aux);
		return(aux);
	}

	// Obtem substring
	public String getSubstring(String buf, int pos)
	{
		int idx;
		char caract;

		StringBuffer aux = new StringBuffer();
		for(idx=pos; idx<buf.length(); idx++)
		{
			caract=buf.charAt(idx);
			if(caract == ';') break;
			aux.append(caract);
		}

		return aux.toString();
	}

	// Obtem a chave da subString
	public String getSubChave(String msg) throws Exception
	{
		int idx;

		if (msg.length() == 0)
		{
			throw new Exception("String nula");
		}

		try
		{
			idx = msg.indexOf("=");
			if (idx == -1)
			{
				throw new Exception("No achou o separador '='");
			}

			return msg.substring(0, idx);
		}
		catch (Exception e)
		{
			throw e;
		}
	}

	// Obtem a descrio da subString
	public String getSubDescr(String msg) throws Exception
	{
		int idx;

		if (msg.length() == 0)
		{
			throw new Exception("String nula");
		}

		try
		{
			idx = msg.indexOf("=");
			if (idx == -1)
			{
				throw new Exception("No achou o separador '='");
			}

			return msg.substring(idx+1);
		}
		catch (Exception e)
		{
			throw e;
		}
	}
}
