import java.awt.*;
import java.net.*;
import java.awt.event.*;
import java.applet.Applet;
import java.applet.*;

import java.io.PrintStream;
import java.io.DataInputStream;
import java.io.IOException;

public class Auto extends Applet
{
	private static final Parametro param = new Parametro();
	private URL newDocument;

	private Button btOk, btClear;
	private String contexto;
	private Opcao opcao;
	private BufferResult bufferResult;
	private Status status;
	private BufferInput bufferInput;
	private Conexoes conexoes;

	public void init()
	{
		Titulo titulo = new Titulo("Simulador Auto-Atendimento",20,20);
		status = new Status(".",20,20);

		opcao = new Opcao();
		bufferResult = new BufferResult();
		bufferInput = new BufferInput();
		conexoes = new Conexoes();

		/*************************
		 Cria a Panel de comando
		*************************/

		btOk = new Button();
		btOk.setLabel("   Ok   ");
		btOk.setEnabled(true);
		btOk.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					status.setMensag("Enviando solicitao... Aguarde !" );
					getURL();
				}
			});

		btClear = new Button();
		btClear.setLabel("Limpa Buffer");
		btClear.setEnabled(true);
		btClear.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					clear();
				}
			});

		Panel pnlButton = new Panel(new GridLayout(2,1,5,5));
		pnlButton.add(btOk);
		pnlButton.add(btClear);

		Panel pnlArea = new Panel(new GridLayout(1,2,5,5));
		pnlArea.add(bufferInput);
		pnlArea.add(bufferResult);

		Panel pnlConfirma = new Panel(new FlowLayout());
		pnlConfirma.add(pnlButton);

 		Panel pnlSup = new Panel(new BorderLayout(10,10));
 		pnlSup.add(titulo, BorderLayout.NORTH);
 		pnlSup.add(opcao, BorderLayout.WEST);
 		pnlSup.add(conexoes, BorderLayout.CENTER);
 		pnlSup.add(pnlConfirma, BorderLayout.EAST);

		setLayout(new BorderLayout());
		add(pnlSup, BorderLayout.NORTH);
		add(pnlArea, BorderLayout.CENTER);
		add(status, BorderLayout.SOUTH);

		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
		setFont(param.getFonteMedia());

		isOpcao1();
	}

	public void clear()
	{
		bufferResult.clear();
		bufferInput.clear();
		status.setMensag(".");
	}

	public boolean isOpcao1()
	{
		boolean transac = opcao.getOpcao1();
		if(transac)
		{
			StringBuffer buf = new StringBuffer();
			buf.append( "?param=" );
			buf.append( param.xml_transac(5000) );
			buf.append( param.xml_str("CELULAR", "1212126128") );

			clear();
			bufferInput.append(buf.toString());
		}
		return transac;
	}

	public boolean isOpcao2()
	{
		boolean transac = opcao.getOpcao2();
		if(transac)
		{
			StringBuffer buf = new StringBuffer();
			buf.append( "?param=" );
			buf.append( param.xml_transac(2) );
			buf.append( param.xml_str("CELULAR", "1212126128") );
			buf.append( param.xml_str("TIPO_CEL", "PRE") );
			buf.append( param.xml_str("DTATV", "19990514") );
			buf.append( param.xml_str("NOM", "MARCIO AUXILIO BEZERRA ALENCAR") );
			buf.append( param.xml_str("SEX", "M") );
			buf.append( param.xml_str("DTNSC", "19700314") );
			buf.append( param.xml_str("LOGR", "AV") );
			buf.append( param.xml_str("END", "JOSE BARBOSA DE SIQUEIRA") );
			buf.append( param.xml_str("NUM", "28") );
			buf.append( param.xml_str("CMPL", "apto.x") );
			buf.append( param.xml_str("BRO", "JD. PADROEIRA") );
			buf.append( param.xml_str("MUNIC", "OSASCO") );
			buf.append( param.xml_str("CEP", "01000000") );
			buf.append( param.xml_str("CID", "OSASCO") );
			buf.append( param.xml_str("UF", "SP") );
			buf.append( param.xml_str("EMAIL", "jose@telesp.com.br") );
			buf.append( param.xml_str("ECIVIL", "2"));
			buf.append( param.xml_str("NDEP", "3"));
			buf.append( param.xml_str("PROF", "2"));
			buf.append( param.xml_str("ESCOLA", "3"));
			buf.append( param.xml_str("HIST", "1"));
			buf.append( param.xml_str("ESTAB_NM","teste"));
			buf.append( param.xml_str("ESTAB_NF","123"));
			buf.append( param.xml_str("ESTAB_CNPJ","222333"));
			buf.append( param.xml_str("ESTAB_IE", "55555"));
			buf.append( param.xml_str("DOCTIPO1", "RG"));
			buf.append( param.xml_str("DOCNUM1", "222818437"));
			buf.append( param.xml_str("DOCTIPO2", "CPF"));
			buf.append( param.xml_str("DOCNUM2", "33388959800"));
			buf.append( param.xml_str("OE", "SSP"));
			buf.append( param.xml_str("DTEXP", "20010523"));
			buf.append( param.xml_str("ESTEXP", "SP"));
			buf.append( param.xml_str("NMCONT", "eu"));
			buf.append( param.xml_str("PHCONT>", "021"));
			buf.append( param.xml_str("CC>", "SIM"));
			buf.append( param.xml_str("BANCO>", "UN"));

			clear();
			bufferInput.append(buf.toString());
		}

		return transac;
	}

	public boolean isOpcao3()
	{
		boolean transac = opcao.getOpcao3();
		if(transac)
		{
			StringBuffer buf = new StringBuffer();
			buf.append( "?param=" );
			buf.append( param.xml_transac(21) );
			buf.append( param.xml_str("CELULAR", "1212126128") );

			clear();
			bufferInput.append(buf.toString());
		}
		return transac;
	}

	public boolean isOpcao4()
	{
		boolean transac = opcao.getOpcao4();
		if(transac)
		{
			StringBuffer buf = new StringBuffer();
			buf.append( "?param=" );
			buf.append( param.xml_transac(23) );
			buf.append( param.xml_str("OPERACAO", "2"));
			buf.append( param.xml_str("CELULAR", "1212126128") );
			buf.append( param.xml_str("DTHO", "29-08-2002 15:15:00"));
			buf.append( param.xml_str("STATUS", "0"));
			buf.append( param.xml_str("IP", "172.20.7.32"));
			buf.append( param.xml_str("OBS", "Teste"));

			clear();
			bufferInput.append(buf.toString());
		}
		return transac;
	}

	// Substitui o comando AppletContext.showDocument()
	public void getURL()
  	{
		String result;
		FrameMsg msg;
		final int etx=0x03;

    	try
    	{
			if (bufferInput.getHeight() == 0) return;
			contexto  = bufferInput.getText().replace('\n', '.').replace(' ', '.');
			URL urlTransac = new URL(param.get_Middleware()+contexto);
			URLConnection connection = urlTransac.openConnection();

      		//connection.setDoOutput(true);
      		//PrintStream out = new PrintStream(connection.getOutputStream());
      		//out.println(contexto);
			//out.close();

			DataInputStream in = new DataInputStream(connection.getInputStream());

			StringBuffer arq = new StringBuffer();
			try
			{
				while(true)
				{
					result = in.readLine();
					if(result.length() == 0) break;

System.out.println("result="+result);

					arq.append(result);
					if(result.indexOf(etx) > 0) break;
				}
			}
			catch (Exception ex) {};

      		in.close();

System.out.println("Opcao="+opcao.getOpcao());

      		switch(opcao.getOpcao())
      		{
				case 1:
System.out.println("Erro1");
					exibeOpcao1(arq.toString());
					break;
				case 2:
System.out.println("Erro2");
					exibeOpcao2(arq.toString());
					break;
				case 3:
System.out.println("Erro3");
					exibeOpcao3(arq.toString());
					break;
				case 4:
System.out.println("Erro4");
					exibeOpcao3(arq.toString());
					break;
				default:
System.out.println("Erro5");
					bufferResult.append("Retorno:\n"+arq.toString()+"\n\n");
			}
     	}
      	catch(MalformedURLException mue)
      	{
      		System.out.println("Illegal URL: " + mue);
    	}
    	catch(IOException ioe)
    	{
    		System.out.println("IOException: " + ioe);
    	}
    	catch(Exception e)
    	{
			System.out.println("Error: " + e);
		}
	}

	// Devolve o valor correspondente a tag
	private String getTag(String buf, String tag)
	{
		String aux = param.xml_get(buf, tag);
		if(aux == null)
			return "null";
		else
			return aux;
	}

	// Exibe resposta da opcao1
	private void exibeOpcao1(String buf)
	{
		String celular = getTag(buf, "CELULAR");
		String tipoCel = getTag(buf, "TIPO_CEL");
		String dtatv = getTag(buf, "DTATV");
		String nome = getTag(buf, "NOM");
		String sex = getTag(buf, "SEX");
		String dtnsc = getTag(buf, "DTNSC");
		String logr = getTag(buf, "LOGR");
		String end = getTag(buf, "END");
		String num = getTag(buf, "NUM");
		String cmpl = getTag(buf, "CMPL");
		String bro = getTag(buf, "BRO");
		String munic = getTag(buf, "MUNIC");
		String cep = getTag(buf, "CEP");
		String cid = getTag(buf, "CID");
		String uf = getTag(buf, "UF");
		String email = getTag(buf, "EMAIL");
		String ecivil = getTag(buf, "ECIVIL");
		String ndep = getTag(buf, "NDEP");
		String prof = getTag(buf, "PROF");
		String escola = getTag(buf, "ESCOLA");
		String hist = getTag(buf, "HIST");
		String estab_nm = getTag(buf, "ESTAB_NM");
		String estab_nf = getTag(buf, "ESTAB_NF");
		String estab_cnpj = getTag(buf, "ESTAB_CNPJ");
		String estab_ie = getTag(buf, "ESTAB_IE");
		String doctipo1 = getTag(buf, "DOCTIPO1");
		String doctipo2 = getTag(buf, "DOCTIPO2");
		String docnum1 = getTag(buf, "DOCNUM1");
		String docnum2 = getTag(buf, "DOCNUM2");
		String oe = getTag(buf, "OE");
		String dtexp = getTag(buf, "DTEXP");
		String estexp = getTag(buf, "ESTEXP");
		String nmcont = getTag(buf, "NMCONT");
		String phcont = getTag(buf, "PHCONT");
		String cc = getTag(buf, "CC");
		String banco = getTag(buf, "BANCO");
		String err = getTag(buf, "ERR");
		String err_mens = getTag(buf, "ERR_MENS");

		bufferResult.clear();
		bufferResult.append("Celular.....:"+celular+"\n");
		bufferResult.append("Tipo Celular:"+tipoCel+"\n");
		bufferResult.append("Dt. Ativacao:"+dtatv+"\n");
		bufferResult.append("Nome........:"+nome+"\n");
		bufferResult.append("Sexo........:"+sex+"\n");
		bufferResult.append("Dt. Nascim..:"+dtnsc+"\n");
		bufferResult.append("Logradouro..:"+logr+"\n");
		bufferResult.append("Endereco....:"+end+"\n");
		bufferResult.append("Nmero......:"+num+"\n");
		bufferResult.append("Complem.....:"+cmpl+"\n");
		bufferResult.append("Bairro......:"+bro+"\n");
		bufferResult.append("Municipio...:"+munic+"\n");
		bufferResult.append("CEP.........:"+cep+"\n");
		bufferResult.append("Cidade......:"+cid+"\n");
		bufferResult.append("Mail........:"+email+"\n");
		bufferResult.append("E.Civil.....:"+ecivil+"\n");
		bufferResult.append("Num.Depend..:"+ndep+"\n");
		bufferResult.append("Profissao...:"+prof+"\n");
		bufferResult.append("Escolaridade:"+escola+"\n");
		bufferResult.append("Historico...:"+hist+"\n");
		bufferResult.append("Estab. Nome.:"+estab_nm+"\n");
		bufferResult.append("Estab. N.F..:"+estab_nf+"\n");
		bufferResult.append("Estab. CNPJ.:"+estab_cnpj+"\n");
		bufferResult.append("Estab. IE...:"+estab_ie+"\n");
		bufferResult.append("Doc1........:"+doctipo1+"\n");
		bufferResult.append("Doc2........:"+doctipo2+"\n");
		bufferResult.append("Num. Doc1...:"+docnum1+"\n");
		bufferResult.append("Num. Doc2...:"+docnum2+"\n");
		bufferResult.append("Org.Exp.....:"+oe+"\n");
		bufferResult.append("Data Exp....:"+dtexp+"\n");
		bufferResult.append("Estado Exp..:"+estexp+"\n");
		bufferResult.append("Nome Cont...:"+nmcont+"\n");
		bufferResult.append("Fone Cont...:"+phcont+"\n");
		bufferResult.append("Conta Corr..:"+cc+"\n");
		bufferResult.append("Banco.......:"+banco+"\n");
		bufferResult.append("Err.Mensag..:"+err_mens+"\n");
		status.setMensag(getStatus(err));
	}

	// Exibe resposta da opcao2
	private void exibeOpcao2(String buf)
	{
		String erro = getTag(buf, "ERR");
		String descr = getTag(buf, "ERR_MENS");

		bufferResult.clear();
		bufferResult.append("Mensag:"+descr+"\n");
		status.setMensag(getStatus(erro));
	}

	// Exibe resposta da opcao3
	private void exibeOpcao3(String buf)
	{
		String nf = getTag(buf, "NF");
		String dtemi = getTag(buf, "DTEMI");
		String nome = getTag(buf, "NOME");
		String dtatv = getTag(buf, "DTATV");
		String end = getTag(buf, "END");
		String cep = getTag(buf, "CEP");
		String munic = getTag(buf, "MUNIC");
		String uf = getTag(buf, "UF");
		String cnpj = getTag(buf, "CNPJ");
		String cpf = getTag(buf, "CPF");
		String ie = getTag(buf, "IE");
		String celular = getTag(buf, "CELULAR");
		String serv1 = getTag(buf, "SERV1");
		String vserv1 = getTag(buf, "VSERV1");
		String serv2 = getTag(buf, "SERV2");
		String vserv2 = getTag(buf, "VSERV2");
		String serv3 = getTag(buf, "SERV3");
		String vserv3 = getTag(buf, "VSERV3");
		String serv4 = getTag(buf, "SERV4");
		String vserv4 = getTag(buf, "VSERV4");
		String serv5 = getTag(buf, "SERV5");
		String vserv5 = getTag(buf, "VSERV5");
		String base_icms = getTag(buf, "BASE_ICMS");
		String per_icms = getTag(buf, "PER_ICMS");
		String icms = getTag(buf, "ICMS");
		String tnota = getTag(buf, "TNOTA");
		String quitacao = getTag(buf, "QUITACAO");
		String vquitacao = getTag(buf, "VQUITACAO");
		String serie = getTag(buf, "SERIE");
		String local = getTag(buf, "LOCAL");
		String per_fust = getTag(buf, "PER_FUST");
		String base_fust = getTag(buf, "BASE_FUST");
		String fust = getTag(buf, "FUST");
		String per_funntel = getTag(buf, "PER_FUNNTEL");
		String base_funntel = getTag(buf, "BASE_FUNNTEL");
		String funntel = getTag(buf, "FUNNTEL");
		String err = getTag(buf, "ERR");
		String err_mens = getTag(buf, "ERR_MENS");

		bufferResult.clear();
		bufferResult.append("Nota fiscal.:"+nf+"\n");
		bufferResult.append("Emissao.....:"+dtemi+"\n");
		bufferResult.append("Nome........:"+nome+"\n");
		bufferResult.append("Dt.Ativao.:"+dtatv+"\n");
		bufferResult.append("Endereco....:"+end+"\n");
		bufferResult.append("Cep.........:"+cep+"\n");
		bufferResult.append("Municipio...:"+munic+"\n");
		bufferResult.append("Estado......:"+uf+"\n");
		bufferResult.append("CNPJ........:"+cnpj+"\n");
		bufferResult.append("CPF.........:"+cpf+"\n");
		bufferResult.append("IE..........:"+ie+"\n");
		bufferResult.append("Celular.....:"+celular+"\n");
		bufferResult.append("Serv1.......:"+serv1+"\n");
		bufferResult.append("VServ1......:"+vserv1+"\n");
		bufferResult.append("Serv2.......:"+serv2+"\n");
		bufferResult.append("VServ2......:"+vserv2+"\n");
		bufferResult.append("Serv3.......:"+serv3+"\n");
		bufferResult.append("VServ3......:"+vserv3+"\n");
		bufferResult.append("Serv4.......:"+serv4+"\n");
		bufferResult.append("VServ4......:"+vserv4+"\n");
		bufferResult.append("Serv5.......:"+serv5+"\n");
		bufferResult.append("VServ5......:"+vserv5+"\n");
		bufferResult.append("Base ICMS...:"+base_icms+"\n");
		bufferResult.append("Perc. ICMS..:"+per_icms+"\n");
		bufferResult.append("ICMS........:"+icms+"\n");
		bufferResult.append("Total Nota..:"+tnota+"\n");
		bufferResult.append("Quitao....:"+quitacao+"\n");
		bufferResult.append("Val.Quitao:"+vquitacao+"\n");
		bufferResult.append("Serie.......:"+serie+"\n");
		bufferResult.append("Local.......:"+local+"\n");
		bufferResult.append("Base Fust...:"+base_fust+"\n");
		bufferResult.append("Perc.Fust...:"+per_fust+"\n");
		bufferResult.append("Fust........:"+fust+"\n");
		bufferResult.append("Base Funntel:"+base_funntel+"\n");
		bufferResult.append("Perc.Funntel:"+per_funntel+"\n");
		bufferResult.append("Funntel.....:"+funntel+"\n");
		bufferResult.append("ERR_MENS....:"+err_mens+"\n");
		status.setMensag(getStatus(err));
	}

	// Exibe resposta da opcao4
	private void exibeOpcao4(String buf)
	{
		String erro = getTag(buf, "ERR");
		String descr = getTag(buf, "ERR_MENS");

		bufferResult.clear();
		bufferResult.append("Mensag:"+descr+"\n");
		status.setMensag(getStatus(erro));
	}

	/****************************************************************
	Cdigos de retornos:	0		DATA_OK
							-70		INVALID_SOCKET
							-71		SOCKET_ERROR
							-72		SOCKET_OPEN
							-73		HOSTNAME_NOT_FOUND
							-74		CONNECT_FAIL
							-75		SEND_DATA
							-76		RECEIVE_DATA
							-77		NO_ACKNOLEGE
							-78		NO_ANSWER
							-79 	LISTEN_FAIL
							-80		BIND_FAIL
							-81		SETSOCK_FAIL
							-82		BAD_INPUT_FORMAT

							-1		SEM_RESPOSTA_AUTOS
							-2		SEM_RESPOSTA_PPS
							-3		SEM_RESPOSTA_P2K
							-4		SEM_RESPOSTA_WAP
							-5		CELULAR_NAO_ENCONTRADO
							-6		CELULAR_NAO_ACTIVO
							-7		CELULAR_EM_ESTADO_INCOMPATIVEL
							-8		NAO_CADASTRADO_WAP
							-9		NAO_CADASTRADO_P2K
							-10		TIPO_DOCUM_DESCONHECIDO
							-11		DOCUMENTO_NAO_CORRESPONDE
							-12		CLIENTE_SEM_CADASTRO
							-13		UNKNOWN_TRANSACTION
	****************************************************************/
	private String getStatus(String str)
	{
		Integer cod;
		int codRet;

		try
		{
			cod = new Integer(str);
			codRet = cod.intValue();
		}
		catch (Exception e)
		{
			codRet = 999;
		}

		StringBuffer buf = new StringBuffer();
		buf.append("("+str+"): ");
		switch (codRet)
		{
			case 0:
				buf.append("DATA_OK");
				break;
			case -70:
				buf.append("INVALID_SOCKET");
				break;
			case -71:
				buf.append("SOCKET_ERROR");
				break;
			case -72:
				buf.append("SOCKET_OPEN");
				break;
			case -73:
				buf.append("HOSTNAME_NOT_FOUND");
				break;
			case -74:
				buf.append("CONNECT_FAIL");
				break;
			case -75:
				buf.append("SEND_DATA");
				break;
			case -76:
				buf.append("RECEIVE_DATA");
				break;
			case -77:
				buf.append("NO_ACKNOLEGE");
				break;
			case -78:
				buf.append("NO_ANSWER");
				break;
			case -79:
				buf.append("LISTEN_FAIL");
				break;
			case -80:
				buf.append("BIND_FAIL");
				break;
			case -81:
				buf.append("SETSOCK_FAIL");
				break;
			case -82:
				buf.append("BAD_INPUT_FORMAT");
				break;
			case -1:
				buf.append("SEM_RESPOSTA_AUTOS");
				break;
			case -2:
				buf.append("SEM_RESPOSTA_PPS");
				break;
			case -3:
				buf.append("SEM_RESPOSTA_P2K");
				break;
			case -4:
				buf.append("SEM_RESPOSTA_WAP");
				break;
			case -5:
				buf.append("CELULAR_NAO_ENCONTRADO");
				break;
			case -6:
				buf.append("CELULAR_NAO_ACTIVO");
				break;
			case -7:
				buf.append("CELULAR_EM_ESTADO_INCOMPATIVEL");
				break;
			case -8:
				buf.append("NAO_CADASTRADO_WAP");
				break;
			case -9:
				buf.append("NAO_CADASTRADO_P2K");
				break;
			case -10:
				buf.append("TIPO_DOCUM_DESCONHECIDO");
				break;
			case -11:
				buf.append("DOCUMENTO_NAO_CORRESPONDE");
				break;
			case -12:
				buf.append("CLIENTE_SEM_CADASTRO");
				break;
			case -13:
				buf.append("UNKNOWN_TRANSACTION");
				break;
			default:
				if(codRet == 999)
					buf.append("ERRO="+str);
				else
					buf.append("ERRO="+codRet);
		}
		return buf.toString();
	}

	/*********************
	 Opcoes do simulador
	*********************/
	private class Opcao extends Panel implements ItemListener
	{
		Checkbox chkOpcao1, chkOpcao2, chkOpcao3, chkOpcao4;

		// Construtor
		public Opcao()
		{
			CheckboxGroup cbg = new CheckboxGroup();
			chkOpcao1 = new Checkbox("Consulta Cadastro", cbg, true);
			chkOpcao1.setName("Opcao1");
			chkOpcao1.setBackground( param.get_BackColor() );
			chkOpcao1.addItemListener(this);

			chkOpcao2 = new Checkbox("Cadastro de cliente", cbg, false);
			chkOpcao2.setName("Opcao2");
			chkOpcao2.setBackground( param.get_BackColor() );
			chkOpcao2.addItemListener(this);

			chkOpcao3 = new Checkbox("Nota fiscal de recargas", cbg, false);
			chkOpcao3.setName("Opcao3");
			chkOpcao3.setBackground(param.get_BackColor());
			chkOpcao3.addItemListener(this);

			chkOpcao4= new Checkbox("Nota no sistema pps (Log)", cbg, false);
			chkOpcao4.setName("Opcao4");
			chkOpcao4.setBackground(param.get_BackColor());
			chkOpcao4.addItemListener(this);

			setLayout(new GridLayout(4,1,10,10));
	 		add(chkOpcao1);
			add(chkOpcao2);
	 		add(chkOpcao3);
	 		add(chkOpcao4);
			setBackground(param.get_BackColor());
			setForeground(param.get_ForeColor());
		}

		public int getOpcao()
		{
			if(getOpcao1()) return 1;
			if(getOpcao2()) return 2;
			if(getOpcao3()) return 3;
			if(getOpcao4()) return 4;
			return 0;
		}

		public boolean getOpcao1()
		{
			return chkOpcao1.getState();
		}

		public boolean getOpcao2()
		{
			return chkOpcao2.getState();
		}

		public boolean getOpcao3()
		{
			return chkOpcao3.getState();
		}

		public boolean getOpcao4()
		{
			return chkOpcao4.getState();
		}

		public void setOpcao(int opc)
		{
			switch(opc)
			{
				case 1:	chkOpcao1.setState(true);
						break;
				case 2:	chkOpcao2.setState(true);
						break;
				case 3:	chkOpcao3.setState(true);
						break;
				case 4:	chkOpcao4.setState(true);
						break;
			}
		}

		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			Dimension d = getSize();

			g.setColor(param.get_BackColor());
			g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

			g.setColor(Color.yellow);
			g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);
		}

		public Insets getInsets()
		{
			return new Insets(10,10,10,10);
		}

		/*****************************************************************************
		Verifica quem originou o evento e define se o boto deve ou no ser habilitado
		******************************************************************************/
		public void itemStateChanged(ItemEvent e)
		{
			if ( e.getSource() == chkOpcao1 )
			{
				if ( chkOpcao1.getState() ) isOpcao1();
				return;
			}

			if ( e.getSource() == chkOpcao2 )
			{
				if ( chkOpcao2.getState() ) isOpcao2();
				return;
			}

			if ( e.getSource() == chkOpcao3 )
			{
				if ( chkOpcao3.getState() ) isOpcao3();
				return;
			}

			if ( e.getSource() == chkOpcao4 )
			{
				if ( chkOpcao4.getState() ) isOpcao4();
				return;
			}
		}
	}

	/****************
	 rea do status
	****************/
	private class BufferResult extends Panel
	{
		private TextArea txaStatus;

		// Construtor
		public BufferResult()
		{
			txaStatus = new TextArea();
			txaStatus.setForeground(param.getForeColorText());
			txaStatus.setFont(new Font("Arial",Font.PLAIN + Font.BOLD,10));
			txaStatus.setBackground(Color.lightGray);
			txaStatus.setForeground(param.FORECOLOR_TEXT);

			setLayout(new BorderLayout());
			add(txaStatus, BorderLayout.CENTER);
		}

		public void clear()
		{
			txaStatus.setText("");
		}

		public void append(String str)
		{
			txaStatus.append(str);
		}

		public String getText()
		{
			return txaStatus.getText();
		}

		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			Dimension d = getSize();

			g.setColor(param.get_BackColor());
			g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

			g.setColor(Color.yellow);
			g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);

			g.setFont(new Font("TimesRoman",Font.ITALIC + Font.BOLD,16));
			g.drawString("Resposta", 10, 22);	// ("titulo", posX, posY)
		}

		public Insets getInsets()
		{
			return new Insets(25,10,10,10);
		}
	}

	/****************
	 rea de envio
	****************/
	private class BufferInput extends Panel
	{
		private TextArea txaInput;

		// Construtor
		public BufferInput()
		{
			txaInput = new TextArea();
			txaInput.setForeground(param.getForeColorText());
			txaInput.setFont(new Font("Courier",Font.PLAIN + Font.BOLD,10));
			txaInput.setBackground(Color.lightGray);
			txaInput.setForeground(param.FORECOLOR_TEXT);

			setLayout(new BorderLayout());
			add(txaInput, BorderLayout.CENTER);
		}

		public void clear()
		{
			txaInput.setText("");
		}

		public void append(String str)
		{
			txaInput.append(str);
		}

		public String getText()
		{
			return txaInput.getText();
		}

		public int getHeigth()
		{
			try
			{
				return txaInput.getHeight();
			}
			catch (Exception e)
			{
				return 0;
			}
		}

		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			Dimension d = getSize();

			g.setColor(param.get_BackColor());
			g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

			g.setColor(Color.yellow);
			g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);

			g.setFont(new Font("TimesRoman",Font.ITALIC + Font.BOLD,16));
			g.drawString("Envio", 10, 22);
		}

		public Insets getInsets()
		{
			return new Insets(25,10,10,10);
		}
	}


	/****************
	 rea de envio
	****************/
	private class Conexoes extends Panel
	{
		public void paint (Graphics g)
		{
			update(g);
		}

		public void update(Graphics g)
		{
			Dimension d = getSize();

			g.setColor(param.get_BackColor());
			g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

			g.setColor(Color.yellow);
			g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);

			g.setColor(Color.white);
			g.setFont(param.getFontePequena());
			g.drawString(param.get_Middleware(), 10, 22);
			g.drawString("Socket:"+param.get_remoteHost()+" Porta:"+param.get_remotePort(), 10,42);
			g.drawString("Log:"+param.get_logFile(), 10,62);
		}

		public Insets getInsets()
		{
			return new Insets(10,10,10,10);
		}
	}
}