import java.awt.*;
import java.applet.Applet;

public class Aviso extends Applet
{
	private static final Parametro param = new Parametro();
	private Dimension size;
	private String titulo, mensagem;

	public void init()
	{
		/****************
		 Obtem parametros
		*****************/
		titulo = getParameter("titulo");
		mensagem = getParameter("mensagem");

		setBackground(param.BACKCOLOR);
		setForeground(param.FORECOLOR);

		size = new Dimension(400, 150);
		setSize(size);
	}

	public Dimension getPreferredSize()
	{
		return size;
	}

	public Dimension getMinimumSize()
	{
		return size;
	}

	public Dimension getMaximumSize()
	{
		return size;
	}

	public void paint (Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		Dimension d = getSize();

		g.setColor(param.get_BackColor());
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.yellow);
		g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);

		g.drawString(titulo, 10, 20);
		g.drawString(mensagem, 10, 50);
	}

	public Insets getInsets()
	{
		return new Insets(10,10,10,10);
	}
}
