import java.awt.*;
import java.awt.Image;
import java.net.URL;
import java.net.MalformedURLException;

public class LogoUsuario extends Panel
{
	public static final Parametro param = new Parametro();
	Image image;
	Dimension size;
	String userid, username;

	/*********
	Construtor
	**********/
	LogoUsuario(String userid, String username, Image image)
	{
		this.image = image;
		this.userid = userid;
		this.username = username;

		setBackground(param.get_BackColor());
		setForeground(param.get_ForeColor());
		setFont(param.get_Fonte());

		size = new Dimension(170, 170);
		setSize(size);
	}

	public Dimension getPreferredSize()
	{
		return size;
	}

	public Dimension getMinimumSize()
	{
		return size;
	}

	public Dimension getMaximumSize()
	{
		return size;
	}

	public void paint(Graphics g)
	{
		update(g);
	}

	public void update(Graphics g)
	{
		Dimension d = getSize();

		g.setColor(param.get_BackColor());
		g.fill3DRect(0, 0, d.width - 1, d.height - 1, true);

		g.setColor(Color.yellow);
		g.drawRoundRect(5, 5, d.width - 10, d.height - 10, 10, 10);

		g.drawImage(image, 20, 10, this);
		g.drawString("Usurio:", 10, d.height - 40);
		//g.drawString("Nome:", 10, d.height - 20);

		g.drawString(userid, 58, d.height - 40);
		g.drawString(username, 10, d.height - 20);
   	}
}
