import java.awt.*;
import java.awt.event.*;
import java.awt.Label;

public class FrameMensag extends Frame
{
	private Button btOk;
	private Dimension size;

	private Font lbl_font = new Font("Arial", Font.ITALIC, 12);
	private Font msg_font = new Font("Arial", Font.PLAIN, 12);
	public final static Color BG = Color.lightGray;
	public final static Color FG = Color.black;

	public FrameMensag(String titulo, String mens)
	{
		super(titulo);

		btOk = new Button();
		btOk.setLabel("Ok");
		btOk.setEnabled(true);
		btOk.addActionListener(
			new ActionListener()
			{
				public void actionPerformed (ActionEvent e )
				{
					dispose();
				}
			});

		Panel panelMens = new Panel(new FlowLayout(FlowLayout.CENTER,5,5));
		TextArea txtMens = new TextArea(mens, 3, 50);
		txtMens.setBackground(BG);
		txtMens.setForeground(FG);
		txtMens.setFont(msg_font);
		txtMens.setEnabled(false);
		panelMens.add(txtMens);

		Panel panelOk = new Panel(new FlowLayout(FlowLayout.CENTER,5,5));
		panelOk.add(btOk);

		setLayout(new BorderLayout(5,5));
		add (panelMens, BorderLayout.NORTH);
		add (panelOk, BorderLayout.SOUTH);

		setBackground(BG);
		setForeground(FG);
		setResizable(false);

		// Centraliza o frame
		setSize(400,150);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = getSize();
		setLocation ( (screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		show();
	}
}
