// Configurao de parametros

public class Parametro
{
	public static final String homeTitulo="HOME - INTERNACIONAL";
	public static final String homeHTTP="http://10.21.30.111:8080/stecno/servlet/";
	//public static final String homeHTTP="http://localhost:8080/stecno/servlet/";
	public static final String homeApplet="/stecno/applets/";
	public static final String homeValidaLogin="HTTPGetHomeValidaLogin";
	public static final String homeCliente="HTTPGetHomeCliente";
	public static final String homeLogin="HTTPGetHomeLogin";
	public static final String homeCelular="HTTPGetHomeCelular";
	public static final String homeAviso="HTTPGetHomeAviso";
	public static final String homeDados="HTTPPostHome";
	public static final String homeTelesp="http://www.telespcelular.com.br";
	public static final Character aspasDuplas = new Character('"');

	public static final String codeCliente=" code=Cliente.class width=600 height=380>\n";
	public static final String codeAviso=" code=Aviso.class width=400 height=150>\n";
	public static final String codeCelular=" code=Celular.class width=200 height=180>\n";
	public static final String codeLogin=" code=Login.class width=200 height=130>\n";

	public static final String fundo="/stecno/images/h_fundo2.jpg";
	public static final int remotePort=5001;
	//public static final String remoteHost="10.254.1.131";
	public static final String remoteHost="200.212.96.28";
	public static final String TARGET_WINDOW="_self";
	public static int seq=0;

	//public static final String logFile="/teste/jakarta-tomcat-3.2.1/webapps/stecno/debug/home";
	public static final String logFile="home";

	public static String get_logFile()
	{
		return logFile;
	}

	public static String get_homeTitulo()
	{
		return homeTitulo;
	}

	public static String get_homeApplet()
	{
		return (aspasDuplas + homeApplet + aspasDuplas);
	}

	public static String get_homeValidaLogin()
	{
		return homeHTTP + homeValidaLogin;
	}

	public static String get_homeCliente()
	{
		return homeHTTP + homeCliente;
	}

	public static String get_homeLogin()
	{
		return homeHTTP + homeLogin;
	}

	public static String get_homeCelular()
	{
		return homeHTTP + homeCelular;
	}

	public static String get_homeAviso()
	{
		return homeHTTP + homeAviso;
	}

	public static String get_homeDados()
	{
		return homeHTTP + homeDados;
	}

	public static String get_homeTelesp()
	{
		return homeTelesp;
	}

	public static String get_codeCliente()
	{
		return codeCliente;
	}

	public static String get_codeAviso()
	{
		return codeAviso;
	}

	public static String get_codeCelular()
	{
		return codeCelular;
	}

	public static String get_codeLogin()
	{
		return codeLogin;
	}

	// Cria parametros
	public String criaParam(String tit, int index, String val)
	{
		if (index == 0)
			return ("<param name=" + tit.trim() + retValue( val ));
		else
			return ("<param name=" + tit.trim() + index + retValue( val ));
	}

	private String retValue(String val)
	{
		String tmp = val.trim();
		//if (tmp.length() == 0) tmp = ".";

		return (" value=" + aspasDuplas + tmp + aspasDuplas + ">\n");
	}

	public static Character get_aspasDuplas()
	{
		return aspasDuplas;
	}

	public static String get_fundo()
	{
		return get_aspasDuplas() + fundo + get_aspasDuplas();
	}

	public static int get_remotePort()
	{
		return remotePort;
	}

	public static String get_remoteHost()
	{
		return remoteHost;
	}

	// Texto inicial do html
	public String get_HTML_Inicio()
	{
		return get_HTML_Inicio(get_homeTitulo() );
	}

	public String get_HTML_Inicio(String titulo)
	{
		StringBuffer buf = new StringBuffer();
		buf.append("<html>\n");
		buf.append("<head><title>" + titulo + "</title></head>\n" );
		buf.append("<body background=" + get_fundo() + ">\n");
		buf.append("<center>\n");
		buf.append("<font color=\"gold\" size=\"3\" face=\"Arial\">\n");
		buf.append("<h1>" + titulo + "</h1>\n");
		buf.append("</font>\n");
		buf.append("</center>\n");
		//buf.append("<hr>\n");
		buf.append("<p align=\"center\">\n");
		buf.append("<applet codebase=" + get_homeApplet());
		return buf.toString();
	}

	public String get_HTML_Inicio(String titulo, String sessao)
	{
		StringBuffer buf = new StringBuffer();
		buf.append("<html>\n");
		buf.append("<head><title>" + titulo + "</title></head>\n" );
		buf.append("<body background=" + get_fundo() + ">\n");
		buf.append("<center>\n");
		buf.append("<font color=\"gold\" size=\"3\" face=\"Arial\">\n");
		buf.append("<h1>" + titulo + "</h1>\n");
		buf.append( sessao );
		buf.append("</font>\n");
		buf.append("</center>\n");
		//buf.append("<hr>\n");
		buf.append("<p align=\"center\">\n");
		buf.append("<applet codebase=" + get_homeApplet());
		return buf.toString();
	}

	// Texto final do html
	public String get_HTML_Fim()
	{
		StringBuffer buf = new StringBuffer();
		buf.append( "alt=" + get_aspasDuplas() + "Seu 'browser' no entende o &lt;APPLET&gt;");
		buf.append( "tag porm o applet no est rodando o applet por alguma razo." + get_aspasDuplas());
		buf.append( "Seu 'browser' esta ignorando completamente o &lt;APPLET&gt; tag!");
		buf.append( "</applet>");
		//buf.append( "<hr>\n");
		buf.append( "</body>\n");
		buf.append( "</html>\n");
		return buf.toString();
	}

	// HTML para interromper processo
	public String get_HTML_Interromper(String titulo, String mensagem)
	{
		return makeHTML(titulo, mensagem, get_homeLogin());
	}

	// HTML para interromper processo
	public String get_HTML_Celular(String titulo, String mensagem, String username)
	{
		return makeHTML(titulo, mensagem, get_homeCelular()) + criaParam("username", 0, username);
	}

	// HTML para interromper processo
	private String makeHTML(String titulo, String mensagem, String url)
	{
		StringBuffer aux = new StringBuffer();
		aux.append( get_HTML_Inicio(titulo));
		aux.append( get_codeAviso() );
		aux.append( criaParam("titulo", 0, titulo));
		aux.append( criaParam("mensagem", 0, mensagem));
		aux.append( criaParam("url", 0, url));
		return aux.toString();
	}

	// Inicia string no formato XML
	public String xml_ini()
	{
		return ("<?xml version='1.0' encoding='ISO-8859-1'?>\n");
	}

	// Fabrica string no formato XML
	public String xml_str(String tag, String val)
	{
		String aux =	"<" + tag.toString().trim() + ">" + val.toString().trim() +
						"</" + tag.toString().trim() + ">\n";
		return aux;
	}

	// Fabrica string no formato XML
	public String xml_str(String tag, int val)
	{
		Integer num = new Integer(val);

		String aux =	"<" + tag.toString().trim() + ">" + num.toString() +
						"</" + tag.toString().trim() + ">\n";
		return aux;
	}

	// Fabrica string da transao no formato XML
	public String xml_transac(int val)
	{
		Integer num = new Integer(val);
		return (xml_str("TRANSAC", num.toString()));
	}

	// Devolve string formatado em XML
	public String xml_get(String buffer, String tag)
	{
		String tag1 = "<" + tag.toString().trim() + ">";
		String tag2 = "</" + tag.toString().trim() + ">";
		String resp;
		int pos1, pos2;

		resp = "";
		pos1 = buffer.indexOf(tag1);
		pos2 = buffer.indexOf(tag2);

		if(pos1 != -1)
		{
			pos1 = pos1 + tag1.length();
			if (pos2 != -1)
			{
				if(pos1 < pos2)
				{
					resp = buffer.substring(pos1,pos2);
				}
			}
		}

		return resp;
	}

	// Devolve string com o cdigo de erro
	public String getCodigoErro(String msg)
	{
		int i = msg.indexOf(",");
		if (i > 0)
			msg = msg.substring(0, i);
		else
			msg = "Erro";
		return msg;
	}

	// Devolve descricao do erro
	public String getDescricaoErro(String msg)
	{
		int i = msg.indexOf(",");
		if (i > 0) msg = msg.substring(++i).trim();
		return msg;
	}

	// Devolve controle sequencial
	public static String getCtrl()
	{
		String aux = " :ctrl=" + (++seq);
		System.out.println(aux);
		return(aux);
	}
}
